<?php

defined('ABSPATH') or die("No direct script access!");

/* admin settings page */
require_once('minify/minifier-settings.php');

/* all minify function page */
require_once('minify/src/Minify.php');
require_once('minify/src/CSS.php');
require_once('minify/src/JS.php');

require_once('minify/src/Exception.php');
require_once('minify/src/Exceptions/BasicException.php');
require_once('minify/src/Exceptions/FileImportException.php');

require_once('minify/path-converter/src/ConverterInterface.php');
require_once('minify/path-converter/src/Converter.php');

use Quantumcloud_express\Minify;


add_filter( 'script_loader_tag', 'qcld_expresses_pro_script_load', 100, 3 );
if (!function_exists('qcld_expresses_pro_script_load')) {
function qcld_expresses_pro_script_load( $tag, $handle, $src ) {
    //$defer_load_js = true;



    $defer_load_js = get_option('qcld_express_defer_load_js');
    $qcld_express_optimize_js_code = get_option('qcld_express_optimize_js_code');

    $qcld_expresse_do_activation_optimize_js = get_option('qcld_expresse_do_activation_optimize_js');


    if ( (isset($defer_load_js) && ($defer_load_js == 1) ) || ( isset($qcld_express_optimize_js_code) && ($qcld_express_optimize_js_code == 1) ) ) {

        $handles = array( 
                        'qcld-express-script', 
                        'qcld_express_modal_cart_js', 
                        'qcld_express_magnific_js', 
                        'qcld_express_slick_js', 
                        'qcld_express_sweet_alert_js', 
                        'qcld_express_lightslider_js', 
                        'qcld_express_front_js', 
                        'qcld_express_audio_js', 
                        'qcld-express-script', 
                        'qcld-express-ajax-script', 
                        'qcld_express_sticky_js',  
                        'qcld_express_fronts_js' 
                    );
     
        if ( ! wp_is_mobile() && in_array( $handle, $handles ) ) {


            if ( isset($qcld_express_optimize_js_code) && ($qcld_express_optimize_js_code == '1') ) {

                $name       = basename(parse_url($src, PHP_URL_PATH));
                $ext        = pathinfo(parse_url($src, PHP_URL_PATH), PATHINFO_EXTENSION);
                $name2      = pathinfo(parse_url($src, PHP_URL_PATH), PATHINFO_FILENAME);

                $min_file_path = $name2.".min.".$ext;

                if ( isset($qcld_expresse_do_activation_optimize_js) && ($qcld_expresse_do_activation_optimize_js == 'on') ){
              
                    $sourcePath = file_get_contents($src);
                    $minifier = new Minify\JS($sourcePath);

                    /*$fileLocation = dirname(__FILE__)  . "/assets/js/".$min_file_path;
                    $file = fopen($fileLocation,"w");
                    $content = $minifier;
                    fwrite($file,$content);
                    fclose($file);*/
                   
                    // save minified file to disk
                    $minifiedPath = dirname(__FILE__) ."/assets/js/".$min_file_path;
                    $minifier->minify($minifiedPath);

                    if ( 'qcld-express-ajax-script' == $handle  ){
                        update_option('qcld_expresse_do_activation_optimize_js', 'off');
                    }

                }

        

                $minifiedurl = $min_file_path;

                $tag = str_replace(
                    $name,
                    $minifiedurl,
                    $tag
                );

            }

            if ( $defer_load_js == 1 ){
                return str_replace(' src', ' defer src', $tag);
            }

        }
    }



   

    return $tag;

}
}


add_filter( 'style_loader_tag', 'qcld_expresses_pro_style_min_load', 199, 3 );
if (!function_exists('qcld_expresses_pro_style_min_load')) {
function qcld_expresses_pro_style_min_load( $tag, $handle, $src ){
    //$defer_load_js = true;

    $qcld_express_optimize_css_code = get_option('qcld_express_optimize_css_code');
    $qcld_expresse_do_activation_optimize_css = get_option('qcld_expresse_do_activation_optimize_css');

    if ( isset($qcld_express_optimize_css_code) && ($qcld_express_optimize_css_code == 1) ) {

        $handles = array( 
                        'qcld_express_fontawesome_css', 
                        'qcld-express-stylesheet',
                        'qcld_express_slick_css',
                        'qcld_express_frontend_css',
                        'qcld_express_magnific_css',
                        'qcld_express_front_rwd_css',
                        'qcld_express_sweet_alert_css',
                        'qcld_express_lightslider_css',
                        'qcld_express_animate_css',
                        'qcld_express_audio_css',
                        'qcld_express_front_css'
                    );
     
        if ( ! wp_is_mobile() && in_array( $handle, $handles ) ) {

            $name       = basename(parse_url($src, PHP_URL_PATH));
            $ext        = pathinfo(parse_url($src, PHP_URL_PATH), PATHINFO_EXTENSION); // to get extension
            $name2      = pathinfo(parse_url($src, PHP_URL_PATH), PATHINFO_FILENAME);

            $min_file_path = $name2.".min.".$ext;


            if( isset($qcld_expresse_do_activation_optimize_css) && ($qcld_expresse_do_activation_optimize_css == 'on') ){
          
                $sourcePath = file_get_contents($src);
                $minifier = new Minify\CSS($sourcePath);

               /* $fileLocation = dirname(__FILE__)  . "/assets/css/".$min_file_path;
                $file = fopen($fileLocation,"w");
                $content = $minifier;
                fwrite($file,$content);
                fclose($file);*/
               
                // save minified file to disk
                $minifiedPath = dirname(__FILE__) ."/assets/css/".$min_file_path;
                $minifier->minify($minifiedPath);

                if ( 'qcld-express-stylesheet' == $handle  ){
                    update_option('qcld_expresse_do_activation_optimize_css', 'off');
                }

            }

            $minifiedurl = $min_file_path;

            $tag = str_replace(
                $name,
                $minifiedurl,
                $tag
            );

        }

    }

    return $tag;

}
}


if (!function_exists('qcld_expresses_pro_upgrade_completed')) {
    function qcld_expresses_pro_upgrade_completed( $upgrader_object, $options ) {
        
        // The path to our plugin's main file
        $our_plugin = plugin_basename( __FILE__ );
        // If an update has taken place and the updated type is plugins and the plugins element exists
        if( $options['action'] == 'update' && $options['type'] == 'plugin' && isset( $options['plugins'] ) ) {
            // Iterate through the plugins being updated and check if ours is there
            foreach( $options['plugins'] as $plugin ) {
                if( $plugin == $our_plugin ) {
                    // Your action if it is your plugin
                    update_option('qcld_expresse_do_activation_optimize_css', 'on');
                    update_option('qcld_expresse_do_activation_optimize_js', 'on');
                }
            }
        }

    }
}
add_action( 'upgrader_process_complete', 'qcld_expresses_pro_upgrade_completed', 10, 2 );

// regenerate min css and js
add_action('wp_ajax_qcld_express_regenerate_css_js', 'qcld_express_regenerate_css_js_code');
add_action('wp_ajax_nopriv_qcld_express_regenerate_css_js', 'qcld_express_regenerate_css_js_code');
if (!function_exists('qcld_express_regenerate_css_js_code')) {
    function qcld_express_regenerate_css_js_code(){

        check_ajax_referer( 'qcld_express_security_nonce', 'security');

        update_option('qcld_expresse_do_activation_optimize_css', 'on');
        update_option('qcld_expresse_do_activation_optimize_js', 'on');


        $response = esc_html('Minified JavaScript and CSS files Re-genarated');
        echo wp_send_json($response);
        wp_die();
    }
}

// delete wp cache
add_action('wp_ajax_qcld_express_regenerate_cache', 'qcld_express_regenerate_cache_code');
add_action('wp_ajax_nopriv_qcld_express_regenerate_cache', 'qcld_express_regenerate_cache_code');
if (!function_exists('qcld_express_regenerate_cache_code')) {
    function qcld_express_regenerate_cache_code(){

        check_ajax_referer( 'qcld_express_security_nonce', 'security');

        $cache_key = 'qcld_express_template_results_cache_basic';
        delete_transient( $cache_key );

        $cache_key_animation = 'qcld_express_template_results_cache_animation';
        delete_transient( $cache_key_animation );
        
        $cache_key_gradient = 'qcld_express_template_results_cache_gradient';
        delete_transient( $cache_key_gradient );
        
        $cache_key_restaurent = 'qcld_express_template_results_cache_restaurent';
        delete_transient( $cache_key_restaurent );
        
        $cache_key_restaurent_2 = 'qcld_express_template_results_cache_restaurent-2';
        delete_transient( $cache_key_restaurent_2 );
        
        $cache_key_slope = 'qcld_express_template_results_cache_slope';
        delete_transient( $cache_key_slope );
        
        $cache_key_catalog = 'qcld_express_template_results_cache_catalog';
        delete_transient( $cache_key_catalog );
        

        $response = esc_html('Successfully cache cleared');
        echo wp_send_json($response);
        wp_die();
    }
}

//Loading admin panel's requried Style & scripts
function qcld_express_pro_minify_load_admin_scripts(){

    wp_enqueue_script( 'qcld_express_minify_admin_js', plugin_dir_url(__FILE__) . "/minify/qcld-express-minify-admin.js", array('jquery'), '', true);

    $qcld_ajax = array(
                'admin_url'                     => admin_url( 'admin-ajax.php', is_ssl() ? 'https' : 'http' ),
                'qcld_express_security_nonce'   => wp_create_nonce('qcld_express_security_nonce'),
            );
    wp_localize_script( 'qcld_express_minify_admin_js', 'qcld_minify_ajax', $qcld_ajax );
}
add_action( 'admin_enqueue_scripts', 'qcld_express_pro_minify_load_admin_scripts');