<?php
defined('ABSPATH') or die("No direct script access!");

//variation for variable product
add_action( 'qcld_express_product_variation', 'woocommerce_template_single_price');
add_action( 'qcld_express_product_variation', 'woocommerce_template_single_add_to_cart');

add_action('wp_ajax_get_vp_attributes', 'qcld_express_pro_get_v_product');
add_action('wp_ajax_nopriv_get_vp_attributes', 'qcld_express_pro_get_v_product');
function qcld_express_pro_get_v_product(){

    check_ajax_referer( 'qcld_express_security_nonce', 'security');

    //$attributes = $product->get_attributes();
    $p_id = trim($_POST['p_id']);
    $inStock = "<strong>InStock</strong>";
    //Woocommerce product factory
    $wc_pf = new WC_Product_Factory();
    $product = $wc_pf->get_product($p_id);

    ob_start();
    ?>
    <div class="qcld-express-popup-table">
        <div class="qcld-express-popup-row">
            <div class="qcld-express-popup-col-12">
                <h2 id="qcld_epress_product_title"><?php echo  $product->get_title();?></h2>
            </div>
        </div>
        <div class="qcld-express-popup-row">
            <div class="qcld-express-popup-col-12">
                <?php
                global $woocommerce;

                $suffix  = defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ? '' : '.min';


                global $post;
                if(intval($p_id)) {

                    wp('p=' . $p_id . '&post_type=product');
                    ob_start();


                    while (have_posts()) : the_post(); ?>
                        <script>
                         
                            var wc_add_to_cart_variation_params = {"ajax_url": "\/wp-admin\/admin-ajax.php"};
                            jQuery.getScript("<?php echo $woocommerce->plugin_url(); ?>/assets/js/frontend/add-to-cart-variation.min.js");
                          
                        </script>
                        <div class="express-shop-product-variation-container">
                            <?php
                                do_action('qcld_express_product_variation');
                            ?>
                        </div>

                    <?php endwhile;
                }
                ?>
            </div>
        </div>
    </div>
    <?php
    echo  ob_get_clean();
    exit();
}

add_action('wp_ajax_qcld_express_pro_get_vp_attributes_tooltip', 'qcld_express_pro_get_vp_attributes_tooltip');
add_action('wp_ajax_nopriv_qcld_express_pro_get_vp_attributes_tooltip', 'qcld_express_pro_get_vp_attributes_tooltip');
function qcld_express_pro_get_vp_attributes_tooltip(){

    check_ajax_referer( 'qcld_express_security_nonce', 'security');
    //$attributes = $product->get_attributes();
    $p_id = trim($_POST['p_id']);
    $inStock = "<strong>InStock</strong>";
    //Woocommerce product factory
    $wc_pf = new WC_Product_Factory();
    $product = $wc_pf->get_product($p_id);

    ob_start();
    ?>
    <div class="qcld-express-popup-tooltip">
        <?php
        global $woocommerce;

        $suffix  = defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ? '' : '.min';

        global $post;
        if(intval($p_id)) {

            wp('p=' . $p_id . '&post_type=product');
            ob_start();


            while (have_posts()) : the_post(); ?>
                <script>
                 
                    var wc_add_to_cart_variation_params = {"ajax_url": "\/wp-admin\/admin-ajax.php"};
                    jQuery.getScript("<?php echo $woocommerce->plugin_url(); ?>/assets/js/frontend/add-to-cart-variation.min.js");
                  
                </script>
                <div class="express-shop-product-variation-container">
                    <?php
                        do_action('qcld_express_product_variation');
                    ?>
                </div>

            <?php endwhile;
        }
        ?>
    </div>
    <?php
    echo  ob_get_clean();
    exit();
}

$qcld_express_options = get_option('qcld_express_options');
if(isset($qcld_express_options['qcld_express_redurect_page_add_to_cat']) && $qcld_express_options['qcld_express_redurect_page_add_to_cat'] == 'on' ){

function qcld_express_pro_custom_redirect_function() {

    // Unset all options related to the cart
    update_option( 'woocommerce_cart_redirect_after_add', 'no' );

}
add_action('template_redirect', 'qcld_express_pro_custom_redirect_function');

}

$qcld_express_options = get_option('qcld_express_options');
if( isset($qcld_express_options['qcld_express_cart_mode']) && $qcld_express_options['qcld_express_cart_mode'] == 'wooinstants' ){

function qcld_express_pro_custom_woocommerce_enable_ajax_add_to_cart() {

    // Unset all options related to the cart
    update_option( 'woocommerce_enable_ajax_add_to_cart', 'yes' );

}
add_action('template_redirect', 'qcld_express_pro_custom_woocommerce_enable_ajax_add_to_cart');

}



//Add to cart for variable product.


//Show cart after adding product to cart.
add_action('wp_ajax_show_cart', 'qcld_express_pro_show_cart');
add_action('wp_ajax_nopriv_show_cart', 'qcld_express_pro_show_cart');
function qcld_express_pro_show_cart(){

    check_ajax_referer( 'qcld_express_security_nonce', 'security');

    $html = '';
    $qcld_express_options           = get_option('qcld_express_options');
    $qcld_express_lang_title        = $qcld_express_options['qcld_express_lang_title'];
    $qcld_express_lang_quantity     = $qcld_express_options['qcld_express_lang_quantity'];
    $qcld_express_lang_price        = $qcld_express_options['qcld_express_lang_price'];
    $qcld_express_lang_no_products  = $qcld_express_options['qcld_express_lang_no_products'];
    $qcld_express_lang_cart_total   = $qcld_express_options['qcld_express_lang_cart_total'];
    $qcld_express_lang_items        = $qcld_express_options['qcld_express_lang_items'];

    global $woocommerce;
    $items = $woocommerce->cart->get_cart();
    $itemCount = count($items);
    if ($itemCount >= 1) {
        $html .= '<div class ="qcld-express-table">';
        $html .= '<div class="qcld-express-row"><div class="qcld-express-cell">';
        if(isset($qcld_express_lang_title) && $qcld_express_lang_title != '' ){
            $html .= $qcld_express_lang_title;
        }else{
            $html .= 'Title';
        }
        $html .='</div><div class="qcld-express-cell">';
        if(isset($qcld_express_lang_quantity) && $qcld_express_lang_quantity != '' ){
            $html .= $qcld_express_lang_quantity;
        }else{
            $html .= 'Quantity';
        }
        $html .='</div><div class="qcld-express-cell">';
        if(isset($qcld_express_lang_price) && $qcld_express_lang_price != '' ){
            $html .= $qcld_express_lang_price;
        }else{
            $html .= 'Price';
        }
        $html .='</div></div>';
        foreach ($items as $item => $values) {
            $_product = apply_filters('woocommerce_cart_item_product', $values['data'], $values, $item);
            //product image
            $getProductDetail = wc_get_product($values['product_id']);
            $price = get_post_meta($values['product_id'], '_price', true);

            $html .= '<div class="qcld-express-row">
                        <div class="qcld-express-cell qcld-express-title-cell"> <h3 class="qcld-express-title">';
                            
                                               
                        $product_permalink = apply_filters( 'woocommerce_cart_item_permalink', $_product->is_visible() ? $_product->get_permalink( $values ) : '', $values, $item );
                        $product_name =  apply_filters( 'woocommerce_cart_item_name', sprintf( '<a href="%s">%s</a>', esc_url( $product_permalink ), $_product->get_title() ), $values, $item );

                        $html .= '<p>'.$product_name.'</p>';

                        $attributes = '';

                        //Variation
                        $attributes .= $_product->is_type('variable') || $_product->is_type('variation') ? wc_get_formatted_variation($_product) : '';
                       

                        if($attributes){
                           $html .= $attributes;
                        }
                        $html.='</h3></div>';
                        $html .= '<div class="qcld-express-cell qcld-express-quantity-cell">';
            $html .= '<input class="qcld-cart-item-qnty" data-cart-item="'.$item.'" type="number" min="1" value="'.$values['quantity'].'"></div>';
            $html .= '<div class="qcld-express-cell qcld-express-price-cell"><span>' . apply_filters('woocommerce_cart_item_price', WC()->cart->get_product_price($_product), $values, $item) . '</span> <span data-cart-item="'.$item.'" class="qcld-remove-cart-item"> <i class="fa fa-trash"></i> </span></div> </div>';
        }
        if(isset($qcld_express_lang_items) && $qcld_express_lang_items != ''){
            $qcld_cart_items = $qcld_express_lang_items; 
        }else{
            $qcld_cart_items = 'items';
        }
            
        $html.='<div class="qcld-express-row">
                            <div class="qcld-express-cell"><strong>';
                            if(isset($qcld_express_lang_cart_total) && $qcld_express_lang_cart_total != '' ){
                                $html .= $qcld_express_lang_cart_total;
                            }else{
                                $html .= 'Total';
                            }
                        $html .='</strong></div>
                            <div class="qcld-express-cell">'. $itemCount.' '. $qcld_cart_items.'</div>
                            <div class="qcld-express-cell"><strong>'.$woocommerce->cart->get_cart_total().'</strong></div>
                        </div>';
        $html .= ' </div>';
    } else {
        // qcld_express_lang_cart_total
        if(isset($qcld_express_lang_no_products) && $qcld_express_lang_no_products != '' ){
            $html .= '<div class="qcld_no_cartprods">'.$qcld_express_lang_no_products.'</div>';
        }else{
            $html .= '<div class="qcld_no_cartprods">No products in the cart</div>';
        }
    }
    $response=array('html'=>$html,'items'=>$itemCount);
    echo wp_send_json($response);
    wp_die();
}
//Show item after removing from cart page.
add_action('wp_ajax_remove_item_numbers_from_cart', 'qcld_express_pro_remove_item_numbers_from_cart');
add_action('wp_ajax_nopriv_remove_item_numbers_from_cart', 'qcld_express_pro_remove_item_numbers_from_cart');
function qcld_express_pro_remove_item_numbers_from_cart(){

    check_ajax_referer( 'qcld_express_security_nonce', 'security');
    //getting cart items number getting.
    global $woocommerce;
    $items = $woocommerce->cart->get_cart();
    $itemCount = count($items);

    if($itemCount>1){
        $html='( '.$itemCount.' items )';
    } else if($itemCount==1){
        $html='( '.$itemCount.' item)';
    }else if($itemCount==0){
        $html='( No item )';
    }
    echo wp_send_json($html);
    wp_die();
}
//Show item after removing from cart page.
add_action('wp_ajax_global_cart_item_remove', 'qcld_express_global_cart_item_remove');
add_action('wp_ajax_nopriv_global_cart_item_remove', 'qcld_express_global_cart_item_remove');
function qcld_express_global_cart_item_remove(){

    check_ajax_referer( 'qcld_express_security_nonce', 'security');

    //getting cart items n
    global $woocommerce;
    $cart_item_key  = $_POST['cart_item'];
    $result         = $woocommerce->cart->remove_cart_item($cart_item_key);
    echo wp_send_json($result);
    wp_die();
}
//Cart item number update from global cart.
add_action('wp_ajax_update_cart_item_number', 'qcld_express_update_cart_item_number');
add_action('wp_ajax_nopriv_update_cart_item_number', 'qcld_express_update_cart_item_number');
function qcld_express_update_cart_item_number(){

    check_ajax_referer( 'qcld_express_security_nonce', 'security');
    //getting cart items n
    $cart_item_key  = $_POST['cart_item_key'];
    //$qnty           = $_POST['qnty'];
    $qnty = empty( $_POST['qnty'] ) ? 1 : apply_filters( 'woocommerce_stock_amount', $_POST['qnty'] );
    global $woocommerce;
    $result         = $woocommerce->cart->set_quantity($cart_item_key, $qnty);
    echo wp_send_json($result);
    wp_die();
}

//Load more product
add_action('wp_ajax_load_more', 'qcld_express_pro_load_more');
add_action('wp_ajax_nopriv_load_more', 'qcld_express_pro_load_more');

function qcld_express_pro_load_more(){

    check_ajax_referer( 'qcld_express_security_nonce', 'security');

    // Getting option tree from backend.
    $qcld_express_options       = get_option('qcld_express_options');
    $qcld_express_show_mode     = $qcld_express_options['qcld_express_show_mode'];
    $qcld_express_cart_mode     = $qcld_express_options['qcld_express_cart_mode'];
    $qcld_express_sku           = $qcld_express_options['qcld_express_sku'];
    $qcld_express_thumbnail     = $qcld_express_options['qcld_express_thumbnail'];
    $qcld_express_title         = $qcld_express_options['qcld_express_title'];
    $qcld_express_description   = $qcld_express_options['qcld_express_description'];
    $qcld_express_price         = $qcld_express_options['qcld_express_price'];
    $qcld_express_stock         = $qcld_express_options['qcld_express_stock'];
    $qcld_express_stock_alert   = $qcld_express_options['qcld_express_stock_alert'];
    $qcld_express_action        = $qcld_express_options['qcld_express_action'];
    $qcld_express_background    = $qcld_express_options['qcld_express_background'];
    $qcld_express_altern        = $qcld_express_options['qcld_express_altern'];
    $qcld_express_custom_style  = $qcld_express_options['qcld_express_custom_style'];
    $qcld_express_category_show_above_tite  = $qcld_express_options['qcld_express_category_show_below_tite'];


    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }


    $audio_feature         = $_POST['audio_feature'];
    $video_feature         = $_POST['video_feature'];
    $author                = $_POST['author'];

    // checking audio feature with shortcode enable
    if(!empty($audio_feature) && $audio_feature == 'on'){
        $qcld_express_audio_feature_product  = $audio_feature;
    }elseif(!empty($audio_feature) && $audio_feature == 'off'){
        $qcld_express_audio_feature_product  = $audio_feature;
    }else{
        $qcld_express_audio_feature_product  = $qcld_express_options['qcld_express_audio_feature_product'];
    }

    // checking audio feature with shortcode enable
    if(!empty($video_feature) && $video_feature == 'on'){
        $qcld_express_video_feature_product  = $video_feature;
    }elseif(!empty($video_feature) && $video_feature == 'off'){
        $qcld_express_video_feature_product  = $video_feature;
    }else{
        $qcld_express_video_feature_product  = $qcld_express_options['qcld_express_video_feature_product'];
    }

    if(isset($qcld_express_options['qcld_express_tag']) && $qcld_express_options['qcld_express_tag'] !=''){
    $qcld_express_tag = $qcld_express_options['qcld_express_tag'];
    }else{
    $qcld_express_tag = 'off';

    }

    if(isset($qcld_express_options['qcld_express_tag_lang']) && $qcld_express_options['qcld_express_tag_lang'] !=''){
    $qcld_express_tag_lang = $qcld_express_options['qcld_express_tag_lang'];
    }else{
    $qcld_express_tag_lang = 'Tag';

    }


    if(isset($qcld_express_options['qcld_express_variable_product_show_tooltip']) && $qcld_express_options['qcld_express_variable_product_show_tooltip'] !=''){
    $qcld_express_variable_product_show_tooltip = $qcld_express_options['qcld_express_variable_product_show_tooltip'];
    }else{
    $qcld_express_variable_product_show_tooltip = 'off';

    }


    $qcld_express_short_description_set_character        = $qcld_express_options['qcld_express_short_description_set_character'];
        // sorting variables
    $qcld_express_details_button    = $qcld_express_options['qcld_express_details_button'];
    $qcld_express_product_sorting   = $qcld_express_options['qcld_express_product_sorting'];
    $qcld_express_product_asc_desc  = $qcld_express_options['qcld_express_product_asc_desc'];
    if (isset($qcld_express_options['qcld_express_category'])) {
        $qcld_express_categories = $qcld_express_options['qcld_express_category'];
    } else {
        $qcld_express_categories = array();
    }
    $qcld_express_template         = $qcld_express_options['qcld_express_template'];
    $qcld_express_product_per_page = $qcld_express_options['qcld_express_product_per_page'];
    if(isset($qcld_express_options['qcld_express_lang_in_stock']) && $qcld_express_options['qcld_express_lang_in_stock'] !=''){
    $qcld_express_lang_in_stock = $qcld_express_options['qcld_express_lang_in_stock'];
    }else{
    $qcld_express_lang_in_stock = 'In Stock';
    }
    if(isset($qcld_express_options['qcld_express_lang_out_of_stock']) && $qcld_express_options['qcld_express_lang_out_of_stock'] !=''){
    $qcld_express_lang_out_of_stock = $qcld_express_options['qcld_express_lang_out_of_stock'];
    }else{
    $qcld_express_lang_out_of_stock = 'Out of Stock';
    }
    if(isset($qcld_express_options['qcld_express_lang_from']) && $qcld_express_options['qcld_express_lang_from'] !=''){
    $qcld_express_lang_from = $qcld_express_options['qcld_express_lang_from'];
    }else{
    $qcld_express_lang_from = 'Form';
    }
    if(isset($qcld_express_options['qcld_express_lang_to']) && $qcld_express_options['qcld_express_lang_to'] !=''){
    $qcld_express_lang_to = $qcld_express_options['qcld_express_lang_to'];
    }else{
    $qcld_express_lang_to = 'To';
    }
    //Now filtering the categories to pass to query.
    $terms = get_terms(array(
        'taxonomy' => 'product_cat',
        'hide_empty' => false,
    ));
    $cat_types_id = $_POST['offset'];

    $categories = array();
    foreach ($terms as $term) {
        if (!in_array($term->term_id, $qcld_express_categories)) {
            array_push($categories, $term->term_id);
        }
    }

    $per_page               = $qcld_express_product_per_page;
    $offset                 = $_POST['offset'];
    $link_title_to_modal    = $_POST['link_title_to_modal'];
    $sorting_val            = $_POST['sorting_val'];
    global $woocommerce;
    // Create query arguments array

    if(isset($qcld_express_options['qcld_express_disable_all_cat_button']) && $qcld_express_options['qcld_express_disable_all_cat_button'] !=''){
    $qcld_express_disable_all_cat_button = $qcld_express_options['qcld_express_disable_all_cat_button'];
    }else{
    $qcld_express_disable_all_cat_button = '';

    }

  
    if(isset($qcld_express_disable_all_cat_button) && $qcld_express_disable_all_cat_button == 'on'){

         if($sorting_val == 'popularity'){

            $query_args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'author'            =>  $author,
                'posts_per_page'    =>  $per_page,
                'offset'            =>  $offset,
                'meta_key'          => 'total_sales',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query'         =>  array(
                                            array(
                                                'taxonomy' => 'product_cat',
                                                'field'    => 'term_id',
                                                'terms'    => $categories[0],
                                            ),
                                        ),
                
                                );
        }else if($sorting_val == 'rating'){

            $query_args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'author'            =>  $author,
                'posts_per_page'    =>  $per_page,
                'offset'            =>  $offset,
                'meta_key'          => '_wc_average_rating',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query'         =>  array(
                                            array(
                                                'taxonomy' => 'product_cat',
                                                'field'    => 'term_id',
                                                'terms'    => $categories[0],
                                            ),
                                        ),
                
                                );
        }else if($sorting_val == 'date'){

            $query_args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'author'            =>  $author,
                'posts_per_page'    =>  $per_page,
                'offset'            =>  $offset,
                'orderby'           => 'date',
                'order'             => 'DESC',
                'tax_query'         =>  array(
                                            array(
                                                'taxonomy' => 'product_cat',
                                                'field'    => 'term_id',
                                                'terms'    => $categories[0],
                                            ),
                                        ),
                
                                );
        }else if($sorting_val == 'price'){

            $query_args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'author'            =>  $author,
                'posts_per_page'    =>  $per_page,
                'offset'            =>  $offset,
                'meta_key'          => '_price',
                'orderby'           => 'meta_value_num',
                'order'             => 'ASC',
                'tax_query'         =>  array(
                                            array(
                                                'taxonomy' => 'product_cat',
                                                'field'    => 'term_id',
                                                'terms'    => $categories[0],
                                            ),
                                        ),
                
                                );
        }else if($sorting_val == 'price-desc'){

            $query_args = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'author'            =>  $author,
                'posts_per_page'    =>  $per_page,
                'offset'            =>  $offset,
                'meta_key'          => '_price',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query'         =>  array(
                                            array(
                                                'taxonomy' => 'product_cat',
                                                'field'    => 'term_id',
                                                'terms'    => $categories[0],
                                            ),
                                        ),
                
                                );


        }else{

            $query_args = array(
                'post_type'         =>  array('product', 'product_variation'),
                'post_status'       =>  'publish',
                'author'            =>  $author,
                'posts_per_page'    =>  $per_page,
                'offset'            =>  $offset,
                'orderby'           =>  $qcld_express_product_sorting,
                'order'             =>  $qcld_express_product_asc_desc,
                'tax_query'         =>  array(
                                            array(
                                                'taxonomy' => 'product_cat',
                                                'field'    => 'term_id',
                                                'terms'    => $categories[0],
                                            ),
                                        ),
                
                                );
        }

     }else{

            if($sorting_val == 'popularity'){

                $query_args = array(
                    'post_type'         => array('product', 'product_variation'),
                    'post_status'       => 'publish',
                    'author'            =>  $author,
                    'posts_per_page'    =>  $per_page,
                    'offset'            =>  $offset,
                    'meta_key'          => 'total_sales',
                    'orderby'           => 'meta_value_num',
                    'order'             => 'DESC',
                    'tax_query'         =>  array(
                                                array(
                                                    'taxonomy' => 'product_cat',
                                                    'field'    => 'term_id',
                                                    'terms'    => $categories,
                                                ),
                                            ),
                    
                                    );

            }else if($sorting_val == 'rating'){

                $query_args = array(
                    'post_type'         => array('product', 'product_variation'),
                    'post_status'       => 'publish',
                    'author'            =>  $author,
                    'posts_per_page'    =>  $per_page,
                    'offset'            =>  $offset,
                    'meta_key'          => '_wc_average_rating',
                    'orderby'           => 'meta_value_num',
                    'order'             => 'DESC',
                    'tax_query'         =>  array(
                                                array(
                                                    'taxonomy' => 'product_cat',
                                                    'field'    => 'term_id',
                                                    'terms'    => $categories,
                                                ),
                                            ),
                    
                                    );

            }else if($sorting_val == 'date'){

                $query_args = array(
                    'post_type'         => array('product', 'product_variation'),
                    'post_status'       => 'publish',
                    'author'            =>  $author,
                    'posts_per_page'    =>  $per_page,
                    'offset'            =>  $offset,
                    'orderby'           => 'date',
                    'order'             => 'DESC',
                    'tax_query'         =>  array(
                                                array(
                                                    'taxonomy' => 'product_cat',
                                                    'field'    => 'term_id',
                                                    'terms'    => $categories,
                                                ),
                                            ),
                    
                                    );
            }else if($sorting_val == 'price'){

                $query_args = array(
                    'post_type'         => array('product', 'product_variation'),
                    'post_status'       => 'publish',
                    'author'            =>  $author,
                    'posts_per_page'    =>  $per_page,
                    'offset'            =>  $offset,
                    'meta_key'          => '_price',
                    'orderby'           => 'meta_value_num',
                    'order'             => 'ASC',
                    'tax_query'         =>  array(
                                                array(
                                                    'taxonomy' => 'product_cat',
                                                    'field'    => 'term_id',
                                                    'terms'    => $categories,
                                                ),
                                            ),
                    
                                    );
            }else if($sorting_val == 'price-desc'){

                $query_args = array(
                    'post_type'         => array('product', 'product_variation'),
                    'post_status'       => 'publish',
                    'author'            =>  $author,
                    'posts_per_page'    =>  $per_page,
                    'offset'            =>  $offset,
                    'meta_key'          => '_price',
                    'orderby'           => 'meta_value_num',
                    'order'             => 'DESC',
                    'tax_query'         =>  array(
                                                array(
                                                    'taxonomy' => 'product_cat',
                                                    'field'    => 'term_id',
                                                    'terms'    => $categories,
                                                ),
                                            ),
                    
                                    );
            }else{


                $query_args = array(
                    'post_type'         =>  array('product', 'product_variation'),
                    'post_status'       =>  'publish',
                    'author'            =>  $author,
                    'posts_per_page'    =>  $per_page,
                    'offset'            =>  $offset,
                    'orderby'           =>  $qcld_express_product_sorting,
                    'order'             =>  $qcld_express_product_asc_desc,
                    'tax_query'         =>  array(
                                                array(
                                                    'taxonomy' => 'product_cat',
                                                    'field'    => 'term_id',
                                                    'terms'    => $categories,
                                                ),
                                            ),
                    
                                    );

            }
    }


    if(isset($_POST['c_id'] )){
        $category=sanitize_text_field($_POST['c_id']);
        if($category=='all'){
            $category_ids = sanitize_text_field($_POST['category_ids']);

            if(!empty($category_ids)){
                

                 $query_args = array(
                    'post_type'         =>  array('product', 'product_variation'),
                    'post_status'       =>  'publish',
                    'author'            =>  $author,
                    'posts_per_page'    =>  $per_page,
                    'offset'            =>  $offset,
                    'orderby'           =>  $qcld_express_product_sorting,
                    'order'             =>  $qcld_express_product_asc_desc,
                    'tax_query'         =>  array(
                                                array(
                                                    'taxonomy' => 'product_cat',
                                                    'field'    => 'term_id',
                                                    'terms'    => qcld_express_pro_comma_separated_to_array($category_ids),
                                                ),
                                            ),
                    
                                    );


            }

        }else{
       

             $query_args = array(
                    'post_type'         =>  array('product', 'product_variation'),
                    'post_status'       =>  'publish',
                    'author'            =>  $author,
                    'posts_per_page'    =>  $per_page,
                    'offset'            =>  $offset,
                    'orderby'           =>  $qcld_express_product_sorting,
                    'order'             =>  $qcld_express_product_asc_desc,
                    'tax_query'         =>  array(
                                                array(
                                                    'taxonomy' => 'product_cat',
                                                    'field'    => 'term_id',
                                                    'terms'    => $category,
                                                ),
                                            ),
                    
                                    );


        }
    }

    // Add meta_query to query args
    $query_args['meta_query'] = array();

    // Check products stock status
    $query_args['meta_query'][] = $woocommerce->query->visibility_meta_query();
    $query_args['meta_query'][] = $woocommerce->query->stock_status_meta_query();



    $qcld_express_out_of_stock= isset($qcld_express_options['qcld_express_out_of_stock']) ? $qcld_express_options['qcld_express_out_of_stock'] : '';

    if($qcld_express_out_of_stock == 'on'){

        $query_args = array_merge($query_args, array( 'meta_query' => array(
                    array(
                        'key'       => '_stock_status',
                        'value'     => 'instock',
                    ),
                )));

    }

    //Calculating nextoffset to show button or not.
    $products = get_posts($query_args);
    $product_query = new WP_Query($query_args);
    $products_num = count($products);
    if ($products_num == $per_page) {
        $nextOffset = intval($offset + $per_page);
    } else {
        $nextOffset = -1;
    }
    //Creating WooCommerce product factory.
    $wc_pf = new WC_Product_Factory();
    $html = '';
    $counter = 0;
    $qcld_express_slope_type = 'left';
   // foreach ($products as $P) {
    if ($product_query->have_posts()):
     //foreach($products as $P){
    while ($product_query->have_posts()) : $product_query->the_post();

        $product = $wc_pf->get_product(get_the_ID());
        $getProductDetail = wc_get_product(get_the_ID());
        //Checking for image thumb.
        $qcld_thumb = wp_get_attachment_image_src(get_post_thumbnail_id(get_the_ID()), 'shop_thumbnail');
        $qcld_large = wp_get_attachment_image_src( get_post_thumbnail_id( get_the_ID() ), 'single-post-thumbnail' );
        $audio_not_available = QCLD_EXPRESS_IMG_URL.'/audio-not-available.png';

        if (!empty($qcld_thumb)) {
            $image = $qcld_thumb;
            $image_large =$qcld_large;
        } else {
            $image[0] = QCLD_EXPRESS_IMG_URL . '/placeholder.png';
            $image_large[0]=QCLD_EXPRESS_IMG_URL.'/placeholder.png';
        }
        if ($counter % 2 == 0 && $qcld_express_template == "slope") {
            if ($qcld_express_slope_type == 'left') {
                $qcld_express_extra_class = "left-slope";
                $qcld_express_slope_type = 'right';
            } else {
                $qcld_express_extra_class = "right-slope";
                $qcld_express_slope_type = 'left';
            }

        } else {
            $qcld_express_extra_class = "";
        }
        $html .= '<div class="qcld-express-row ' . $qcld_express_extra_class . '">';
        //SKu show or not
        if (isset($qcld_express_sku) && $qcld_express_sku == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-sku-cell"><p class="qcld-express-sku">' . $product->get_sku() . '</p></div>';
        }
        // Thumbnail show or not
        if (isset($qcld_express_thumbnail) && $qcld_express_thumbnail == 'on') {
           
            $html .= '<div class="qcld-express-cell qcld-express-thumb-cell"><a href="'.$image_large[0].'" class="qcld-express-popup-img"><img class="qlcd-express-list-thumb" src="' . $image[0] . '"  alt="' . get_the_title(get_the_ID()) . '"/></a></div>';
        }
        //Title show or not
        if (isset($qcld_express_title) && $qcld_express_title == 'on') {

            $html .= '<div class="qcld-express-cell qcld-express-title-cell"><h3 class="qcld-express-title">';
             if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .='<a href="#" class="qcld_express_product_details"  product-id="'.get_the_ID().'">' . get_the_title(get_the_ID()) . '</a>';  
            }else{
            $html .='<a href="'.get_the_permalink(get_the_ID()).'"  product-id="'.get_the_ID().'">' . get_the_title(get_the_ID()) . '</a>';  

            }
            if(isset($qcld_express_category_show_above_tite) && $qcld_express_category_show_above_tite == 'on' ){
                $html .= '<p class="qcld-express-categorie">'.wc_get_product_category_list(get_the_ID()).'</p>';
            }
            $html .= '</h3></div>';
        }
        //Description show or not
        if (isset($qcld_express_description) && $qcld_express_description == 'on') {

            $html .= '<div class="qcld-express-cell qcld-express-desc-cell"><p class="qcld-express-desc">' . strip_tags(substr(get_the_excerpt(get_the_ID()), 0, $qcld_express_short_description_set_character )). ' ... ';


            if(isset($qcld_express_details_button) && $qcld_express_details_button == 'on' ){
      
              $html .='<a href="#"  class="qcld_express_product_details" product-id="'.get_the_ID().'">
                  <i class="fa fa-info-circle" aria-hidden="true"></i>
              </a>';
            }
           
            $html .='</p></div>';
        }

    //Tag show or not
    if(isset($qcld_express_tag) && $qcld_express_tag == 'on' ){
     
    $html .='<div class="qcld-express-cell qcld-express-desc-cell">';
          $html .='<p class="qcld-express-desc">';
            

            $qcld_output = array();

            $qcld_terms = wp_get_post_terms( get_the_ID(), 'product_tag' );

            if( count($qcld_terms) > 0 ){
                foreach($qcld_terms as $term){
                    $term_id = $term->term_id;
                    $term_name = $term->name;
                    $term_slug = $term->slug;
                    $term_link = get_term_link( $term, 'product_tag' );

                    $qcld_output[] = '<a href="'.$term_link.'">'.$term_name.'</a>';
                }
                $qcld_output = implode( ', ', $qcld_output );

                $html .= $qcld_output;
            }


            
         $html .='</p></div>';
      }
        

          //Audio show or not
          if(isset($qcld_express_audio_feature_product) && $qcld_express_audio_feature_product == 'on' ){
       
          $html .='<div class="qcld-express-cell qcld-express-audio-cell">';

            
            $qcld_express_audio_title   =   unserialize( get_post_meta( get_the_ID(), 'qcld_express_audio_title', true ));
            $qcld_express_audio_url     =   unserialize( get_post_meta( get_the_ID(), 'qcld_express_audio_url', true ));
               
            if( !empty( $qcld_express_audio_url ) ){
                foreach( $qcld_express_audio_url as $index => $audio_url ){
                    if(isset($audio_url) && !empty($audio_url)){
                        $qcld_express_audio_title = isset($qcld_express_audio_title[$index]) ? $qcld_express_audio_title[$index] : '';
                        $qcld_express_audio_ogg_url = isset($qcld_express_audio_ogg_url[$index]) ? $qcld_express_audio_ogg_url[$index] : '';
            
            $html .='<div class="qcld_express_container">';
            $html .='<div class="qcld_express_audio-player">';
              $html .='<div class="qcld_express_buttons"> <span>';
                $html .='<button type="button" class="qcld_express_prev"></button>';
                $html .='<button type="button" class="qcld_express_play" title="'.esc_attr( $qcld_express_audio_title ).'"></button>';
                $html .='<button type="button" class="qcld_express_pause" title="'.esc_attr( $qcld_express_audio_title ).'"></button>';
                $html .='<button type="button" class="qcld_express_stop"></button>';
                $html .='<button type="button" class="qcld_express_next"></button>';
                $html .='</span> </div>';
              $html .='<div class="clearfix"></div>';
              $html .='<div class="qcld_express_tracker">';
                $html .='<div class="qcld_express_progress-bar"> <span class="qcld_express_progress"></span> </div>';
                $html .='<span class="qcld_express_duration">0:00</span> </div>';
              $html .='<div class="clearfix"></div>';
              $html .='<ul class="qcld_express_playlist qcld_express_hidden">';
                $html .='<li song="'.esc_url( $audio_url ).'" ogg_song="'.esc_url( $qcld_express_audio_ogg_url ).'" cover="cover1.jpg" artist="Linkin Park">'.esc_url( $audio_url ).'</li>';
              $html .='</ul>';
            $html .='</div>';
          $html .='</div>';
                }  } 
            } else{

                  $html .='<div class="qcld_express_container">';
                    $html .='<div class="qcld_express_audio-player">';
                      $html .='<img src="'.esc_url( $audio_not_available ).'">';
                    $html .='</div>';
                  $html .='</div>';
            }

          $html .='</div>';
          }

            // Video show or not
            if(isset($qcld_express_video_feature_product) && $qcld_express_video_feature_product == 'on' ){
             
              $html .='<div class="qcld-express-cell qcld-express-video-cell">';

                $qcld_express_video_name      =   unserialize( get_post_meta( get_the_ID(), 'qcld_express_video_name', true ));
                $qcld_express_video_type      =   unserialize( get_post_meta( get_the_ID(), 'qcld_express_video_type', true ));
                $qcld_express_video_host      =   unserialize( get_post_meta( get_the_ID(), 'qcld_express_video_host', true ));
                $qcld_express_video_url       =   unserialize( get_post_meta( get_the_ID(), 'qcld_express_video_url', true ));

              
                $video_img = QCLD_EXPRESS_IMG_URL.'/video-track.png';
                $audio_not_available = QCLD_EXPRESS_IMG_URL.'/audio-not-available.png';
                   
                if( !empty( $qcld_express_video_name ) ){
                foreach( $qcld_express_video_name as $index => $video_name ){ 
                
                    if(isset($video_name) &&  !empty( $video_name ) ){
                        $qcld_express_video_type = isset($qcld_express_video_type[$index]) ? $qcld_express_video_type[$index] : '';
                        $qcld_express_video_url = isset($qcld_express_video_url[$index]) ? $qcld_express_video_url[$index] : '';
                        $qcld_express_video_host = isset($qcld_express_video_host[$index]) ? $qcld_express_video_host[$index] : '';
               
               
                $html .='<div class="qcld_express_container">';
                $html .='<div class="qcld_express_audio-player">';


                
                  $html .='<a href="#" class="qcld_express_video_modal" video-type="'.esc_attr($qcld_express_video_type).'" video-host="'.esc_attr($qcld_express_video_host).'" video-url="'.$qcld_express_video_url.'" ><img src="'.esc_url( $video_img ).'" alt="'.esc_attr( $video_name ).'" title="'.esc_attr( $video_name ).'"></a>';
                $html .='</div>';
              $html .='</div>';
                } }
                }else{ 
                  $html .='<div class="qcld_express_container">';
                    $html .='<div class="qcld_express_audio-player">';
                      $html .='<img src="'.esc_url( $audio_not_available ).'">';
                    $html .='</div>';
                  $html .='</div>';
                 } 

              $html .='</div>';
            }

        //Availability show or not
        if (isset($qcld_express_stock) && $qcld_express_stock == 'on') {
            $stock = get_post_meta( get_the_ID(), '_stock', true );
            
            $html .= '<div class="qcld-express-cell qcld-express-avail-cell"><p class="qcld-express-avail">';
            if ($stock > 0) {
                $html .= '<span class="qcld-express-avail-in"> '.$qcld_express_lang_in_stock.' (' . $product->get_stock_quantity() . ')</span>';
            } else if($stock=='') {
                $stock_status = get_post_meta( get_the_ID(), '_stock_status', true );
                if( $stock_status == "instock" ){ 
                    $html .= '<span class="qcld-express-avail-out">  '.$qcld_express_lang_in_stock.' </span>';
                }else if( $stock_status == "outofstock" ){
                    $html .= '<span class="qcld-express-avail-outs"> '.$qcld_express_lang_out_of_stock.' </span>';
                } 

            }else if($stock<0) {
                $html .= '<span class="qcld-express-avail-out"> '.$qcld_express_lang_out_of_stock.'</span>';
            }
            $html .= '</p></div>';
        }
        //Price show or not
        if (isset($qcld_express_price) && $qcld_express_price == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-price-cell"><p class="qcld-express-price">' . $product->get_price_html() . '</p></div>';
        }
        // Action show or not
        if (isset($qcld_express_action) && $qcld_express_action == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-action-cell"><ul class="qcld-express-action">';
            if ($product->get_type() == 'simple') {

                $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                    $response_min_max = qcld_express_pro_add_rules_text(get_the_ID(),0);

                    $min_qty  = $response_min_max['min'];
                    $max_qty  = $response_min_max['max'];
                    $step_qty = $response_min_max['step'];
        
    
                    $html.='<li><input type="number" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'" name="qcld_quantity" class="qcld-express-simple-p-qnty"></li>';
                }else{
                $html.='<li><input type="number" value="1" name="qcld_quantity" class="qcld-express-simple-p-qnty"></li>';
                } 


              $stock = get_post_meta( get_the_ID(), '_stock', true );
              $stock_status = get_post_meta( get_the_ID(), '_stock_status', true );
              if( $stock > 0 ){
                    if(isset($qcld_express_cart_mode) && $qcld_express_cart_mode == 'wooinstants') {
                         $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                            $response_min_max = qcld_express_pro_add_rules_text(get_the_ID(),0);
                            $min_qty  = $response_min_max['min'];
                          }else{
                            $min_qty  = 1;

                          }
                     
                     $html .= ' <li><a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple" data-quantity="'.$min_qty.'" data-product_id="' . get_the_ID() . '" p-id="' . get_the_ID() . '"  p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }else{
                     $html .= ' <li><a  href="#"  class="qcld_express_s_p" p-id="' . get_the_ID() . '"p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }

               } else if( $stock == "" ){
               if( $stock_status == "instock" ){

                    if (isset($qcld_express_cart_mode) && $qcld_express_cart_mode == 'wooinstants') {
                         $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                            $response_min_max = qcld_express_pro_add_rules_text(get_the_ID(),0);
                            $min_qty  = $response_min_max['min'];
                          }else{
                            $min_qty  = 1;

                          }
                     
                     $html .= ' <li><a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple" data-quantity="'.$min_qty.'" data-product_id="' . get_the_ID() . '" p-id="' . get_the_ID() . '" p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }else{
                     $html .= ' <li><a  href="#"  class="qcld_express_s_p" p-id="' . get_the_ID() . '"p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }

                } else if( $stock_status == "outofstock" ){ 
                    $html .= ' <li><a href="#" class="qcld_express_out_of_pro" p-id="' . get_the_ID() . '"p-price="' . $product->get_price() . '" > <i class="fa fa-shopping-cart"></i> </a></li>';

                 } 
                }else if( $stock < 1 ){ 

                    if (isset($qcld_express_cart_mode) && $qcld_express_cart_mode == 'wooinstants') {
                         $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                            $response_min_max = qcld_express_pro_add_rules_text(get_the_ID(),0);
                            $min_qty  = $response_min_max['min'];
                          }else{
                            $min_qty  = 1;

                          }
                     
                     $html .= ' <li><a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple" data-quantity="'.$min_qty.'" data-product_id="' . get_the_ID() . '" p-id="' . get_the_ID() . '"p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }else{
                     $html .= ' <li><a  href="#"  class="qcld_express_s_p" p-id="' . get_the_ID() . '"p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }

                } 


            }


             if($product->get_type() == 'external'){

              $link = sprintf( '<a rel="nofollow" href="%s" data-quantity="%s" data-product_id="%s" data-product_sku="%s" class="%s" target="_blank">%s</a>',
                      esc_url( $product->add_to_cart_url() ),
                      esc_attr( isset( $quantity ) ? $quantity : 1 ),
                      esc_attr( $product->get_id() ),
                      esc_attr( $product->get_sku() ),
                      esc_attr( isset( $class ) ? $class : 'qcld_product_type_external' ),
                      esc_html( $product->add_to_cart_text() )
                      );
              $html .= $link;

              }else if ($product->get_type() == 'variable') {
                
              $stock = get_post_meta( get_the_ID(), '_stock', true );
              $stock_status = get_post_meta( get_the_ID(), '_stock_status', true );
              if( $stock > 0 ){
                if($qcld_express_variable_product_show_tooltip == 'on'){
                    $html .= ' <li><a class="qcld_express_v_p_tooltip" p-id="' . get_the_ID() . '"><i class="fa fa-shopping-cart"></i></a></li>';

                }else{
                    $html .= ' <li><a class="qcld_express_v_p" p-id="' . get_the_ID() . '"><i class="fa fa-shopping-cart"></i></a></li>';
                }

               } else if( $stock == "" ){
               if( $stock_status == "instock" ){
                    if($qcld_express_variable_product_show_tooltip == 'on'){
                        $html .= ' <li><a class="qcld_express_v_p_tooltip" p-id="' . get_the_ID() . '"><i class="fa fa-shopping-cart"></i></a></li>';

                    }else{
                        $html .= ' <li><a class="qcld_express_v_p" p-id="' . get_the_ID() . '"><i class="fa fa-shopping-cart"></i></a></li>';
                    }

                } else if( $stock_status == "outofstock" ){ 
                    $html .= ' <li><a href="#" class="qcld_express_out_of_pro" p-id="' . get_the_ID() . '"><i class="fa fa-shopping-cart"></i></a></li>';

                 } 
                }else if( $stock < 1 ){ 
                    if($qcld_express_variable_product_show_tooltip == 'on'){
                        $html .= ' <li><a class="qcld_express_v_p_tooltip" p-id="' . get_the_ID() . '"><i class="fa fa-shopping-cart"></i></a></li>';

                    }else{
                        $html .= ' <li><a class="qcld_express_v_p" p-id="' . get_the_ID() . '"><i class="fa fa-shopping-cart"></i></a></li>';
                    }

                } 

            }
 
            $html .= '</ul>';

            $qcld_woo_minmax_dynamic_pricing_setting = get_option('qcld_woo_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_minmax_install') && (isset($qcld_woo_minmax_dynamic_pricing_setting['qcld_woo_minmax_price_table_on_off']) && $qcld_woo_minmax_dynamic_pricing_setting['qcld_woo_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_express_pro_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }

            $html .= '</div>';
        }//End of show or not
        $html .= '</div>';
        $counter++;
   // } //End of loop

    endwhile;

    endif;

    $output = array('offset' => $nextOffset, 'html' => $html);
    echo wp_send_json($output);


}


function qcld_express_pro_comma_separated_to_array($string, $separator = ','){
  //Explode on comma
  $vals = explode($separator, $string);
  //Trim whitespace
  foreach($vals as $key => $val) {
    $vals[$key] = trim($val);
  }

  return array_diff($vals, array(""));
}

//variation for variable product
//add_action( 'qcld_express_product_variations', 'woocommerce_template_single_price');
add_action( 'qcld_express_product_variations', 'woocommerce_template_single_add_to_cart');




// Product Search by category .....



add_action('wp_ajax_product_search_by_cat', 'qcld_express_pro_product_search_by_cat');
add_action('wp_ajax_nopriv_product_search_by_cat', 'qcld_express_pro_product_search_by_cat');

function qcld_express_pro_product_search_by_cat(){

    check_ajax_referer( 'qcld_express_security_nonce', 'security');

    global $woocommerce;

    /*
    * Code for making compatible with role base price during ajax
    * Added by Mahedi
    */
    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

   // Getting option tree from backend.
    $qcld_express_options       = get_option('qcld_express_options');
    $qcld_express_show_mode     = $qcld_express_options['qcld_express_show_mode'];
    $qcld_express_cart_mode     = $qcld_express_options['qcld_express_cart_mode'];
    $qcld_express_sku           = $qcld_express_options['qcld_express_sku'];
    $qcld_express_thumbnail     = $qcld_express_options['qcld_express_thumbnail'];
    $qcld_express_title         = $qcld_express_options['qcld_express_title'];
    $qcld_express_description   = $qcld_express_options['qcld_express_description'];
    $qcld_express_price         = $qcld_express_options['qcld_express_price'];
    $qcld_express_stock         = $qcld_express_options['qcld_express_stock'];
    $qcld_express_stock_alert   = $qcld_express_options['qcld_express_stock_alert'];
    $qcld_express_action        = $qcld_express_options['qcld_express_action'];
    $qcld_express_background    = $qcld_express_options['qcld_express_background'];
    $qcld_express_altern        = $qcld_express_options['qcld_express_altern'];
    $qcld_express_custom_style  = $qcld_express_options['qcld_express_custom_style'];
    $qcld_express_short_description_set_character        = $qcld_express_options['qcld_express_short_description_set_character'];

    $qcld_express_hide_search_option= $qcld_express_options['qcld_express_hide_search_option'];
    $qcld_express_category_show_above_tite= $qcld_express_options['qcld_express_category_show_below_tite'];

    // Language Change option ... 
    $qcld_express_lang_sku          = $qcld_express_options['qcld_express_lang_sku'];
    $qcld_express_lang_thumbnail    = $qcld_express_options['qcld_express_lang_thumbnail'];
    $qcld_express_lang_title        = $qcld_express_options['qcld_express_lang_title'];
    $qcld_express_lang_desc         = $qcld_express_options['qcld_express_lang_desc'];
    $qcld_express_lang_availability = $qcld_express_options['qcld_express_lang_availability'];
    $qcld_express_lang_price        = $qcld_express_options['qcld_express_lang_price'];
    $qcld_express_lang_action       = $qcld_express_options['qcld_express_lang_action'];
    $qcld_express_lang_search       = $qcld_express_options['qcld_express_lang_search'];
    $qcld_express_lang_cart_summary = $qcld_express_options['qcld_express_lang_cart_summary'];
    $qcld_express_lang_edit_on_cart = $qcld_express_options['qcld_express_lang_edit_on_cart'];
    $qcld_express_lang_checkout     = $qcld_express_options['qcld_express_lang_checkout'];
    $qcld_express_lang_no_products  = $qcld_express_options['qcld_express_lang_no_products'];

        // sorting variables
    $qcld_express_details_button    = $qcld_express_options['qcld_express_details_button'];
    $qcld_express_product_sorting   = $qcld_express_options['qcld_express_product_sorting'];
    $qcld_express_product_asc_desc  = $qcld_express_options['qcld_express_product_asc_desc'];

    $qcld_express_template = $qcld_express_options['qcld_express_template'];

    $qcld_express_product_per_page = $qcld_express_options['qcld_express_product_per_page'];

    if(isset($qcld_express_options['qcld_express_lang_title_placeholder']) && $qcld_express_options['qcld_express_lang_title_placeholder'] !=''){
    $qcld_express_lang_title_placeholder = $qcld_express_options['qcld_express_lang_title_placeholder'];
    }else{
    $qcld_express_lang_title_placeholder = 'Title';

    }
    if(isset($qcld_express_options['qcld_express_lang_sku_placeholder']) && $qcld_express_options['qcld_express_lang_sku_placeholder'] !=''){
    $qcld_express_lang_sku_placeholder = $qcld_express_options['qcld_express_lang_sku_placeholder'];
    }else{
    $qcld_express_lang_sku_placeholder = 'SKU';

    }
    if(isset($qcld_express_options['qcld_express_hot_deals_according_to_cat']) && $qcld_express_options['qcld_express_hot_deals_according_to_cat'] !=''){
    $hot_deail_according_cat = $qcld_express_options['qcld_express_hot_deals_according_to_cat'];
    }else{
    $hot_deail_according_cat = '';
    //hot_deail_according_cat qcld_express_hot_deals_according_to_cat
    }

    if(isset($qcld_express_options['qcld_express_variable_product_show_tooltip']) && $qcld_express_options['qcld_express_variable_product_show_tooltip'] !=''){
    $qcld_express_variable_product_show_tooltip = $qcld_express_options['qcld_express_variable_product_show_tooltip'];
    }else{
    $qcld_express_variable_product_show_tooltip = 'off';

    }
    if(isset($qcld_express_options['qcld_express_lang_in_stock']) && $qcld_express_options['qcld_express_lang_in_stock'] !=''){
    $qcld_express_lang_in_stock = $qcld_express_options['qcld_express_lang_in_stock'];
    }else{
    $qcld_express_lang_in_stock = 'In Stock';
    }
    if(isset($qcld_express_options['qcld_express_lang_out_of_stock']) && $qcld_express_options['qcld_express_lang_out_of_stock'] !=''){
    $qcld_express_lang_out_of_stock = $qcld_express_options['qcld_express_lang_out_of_stock'];
    }else{
    $qcld_express_lang_out_of_stock = 'Out of Stock';
    }
    if(isset($qcld_express_options['qcld_express_lang_from']) && $qcld_express_options['qcld_express_lang_from'] !=''){
    $qcld_express_lang_from = $qcld_express_options['qcld_express_lang_from'];
    }else{
    $qcld_express_lang_from = 'Form';
    }
    if(isset($qcld_express_options['qcld_express_lang_to']) && $qcld_express_options['qcld_express_lang_to'] !=''){
    $qcld_express_lang_to = $qcld_express_options['qcld_express_lang_to'];
    }else{
    $qcld_express_lang_to = 'To';
    }


    if(isset($qcld_express_options['qcld_express_tag']) && $qcld_express_options['qcld_express_tag'] !=''){
    $qcld_express_tag = $qcld_express_options['qcld_express_tag'];
    }else{
    $qcld_express_tag = 'off';

    }

    if(isset($qcld_express_options['qcld_express_tag_lang']) && $qcld_express_options['qcld_express_tag_lang'] !=''){
    $qcld_express_tag_lang = $qcld_express_options['qcld_express_tag_lang'];
    }else{
    $qcld_express_tag_lang = 'Tag';

    }

    // $qcld_express_audio_feature_product = $qcld_express_options['qcld_express_audio_feature_product'];
    // $qcld_express_video_feature_product  = $qcld_express_options['qcld_express_video_feature_product'];

    $audio_feature         = $_POST['audio_feature'];
    $video_feature         = $_POST['video_feature'];
    $author                = $_POST['author'];
    // checking audio feature with shortcode enable
    if(!empty($audio_feature) && $audio_feature == 'on'){
        $qcld_express_audio_feature_product  = $audio_feature;
    }elseif(!empty($audio_feature) && $audio_feature == 'off'){
        $qcld_express_audio_feature_product  = $audio_feature;
    }else{
        $qcld_express_audio_feature_product  = $qcld_express_options['qcld_express_audio_feature_product'];
    }

    // checking audio feature with shortcode enable
    if(!empty($video_feature) && $video_feature == 'on'){
        $qcld_express_video_feature_product  = $video_feature;
    }elseif(!empty($video_feature) && $video_feature == 'off'){
        $qcld_express_video_feature_product  = $video_feature;
    }else{
        $qcld_express_video_feature_product  = $qcld_express_options['qcld_express_video_feature_product'];
    }


    $offset         = $_POST['offset'];
    $category_ids   = $_POST['category_ids'];
    $link_title_to_modal = $_POST['link_title_to_modal'];
    $sorting_val         = isset($_POST['sorting_val']) ? $_POST['sorting_val'] : '';

    if($qcld_express_show_mode=='more' || $qcld_express_show_mode=='scroll'){
        if($qcld_express_product_per_page != ''){
            $per_page=$qcld_express_product_per_page;
            
        }else{

            $per_page=-1;
        }
    }else{
        $per_page=-1;
    }



    //pulling up the product accroding to the query
    // Get WooCommerce Global from Qcld_woo_inc class
    // Create query arguments array
    $category_ids_perameter = '';
     if ($category_ids != '') {
        // if shortcode define category then work here...
        $category_ids = $category_ids;
        $category_ids_perameter = $category_ids;
        $qcld_express_categories = explode(',', $category_ids);

         //Now filtering the categories to pass to query.
        
        $terms = get_terms( array(
            'taxonomy' => 'product_cat',
            'hide_empty' => false,
        ) );

        $categories=array();
        foreach ($terms as $term){
            if(in_array($term->term_id, $qcld_express_categories)){
                array_push($categories,$term->term_id);
            }
        }

    }else{
        // if admin define category then work here...
        if (isset($qcld_express_options['qcld_express_category'])) {
            $qcld_express_categories = $qcld_express_options['qcld_express_category'];
        } else {
            $qcld_express_categories = array();
        }

       
        $terms = get_terms( array(
            'taxonomy' => 'product_cat',
            'hide_empty' => false,
        ) );

        $categories=array();
        foreach ($terms as $term){
            if(!in_array($term->term_id, $qcld_express_categories)){
                array_push($categories,$term->term_id);
            }
        }

    }

        $params=array();

        if($sorting_val == 'popularity'){

            $params = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'author'            => $author,
                'posts_per_page'    => $per_page,
                'offset'            => $offset,
                'meta_key'          => 'total_sales',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query' => array(
                    array(
                        'taxonomy' => 'product_cat',
                        'field'    => 'term_id',
                        'terms'    => $categories,
                    ),
                ),
            );


        }else if($sorting_val == 'rating'){

            $params = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'author'            => $author,
                'posts_per_page'    => $per_page,
                'offset'            => $offset,
                'meta_key'          => '_wc_average_rating',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query' => array(
                    array(
                        'taxonomy' => 'product_cat',
                        'field'    => 'term_id',
                        'terms'    => $categories,
                    ),
                ),
            );

        }else if($sorting_val == 'date'){

            $params = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'author'            => $author,
                'posts_per_page'    => $per_page,
                'offset'            => $offset,
                'orderby'           => 'date',
                'order'             => 'DESC',
                'tax_query' => array(
                    array(
                        'taxonomy' => 'product_cat',
                        'field'    => 'term_id',
                        'terms'    => $categories,
                    ),
                ),
            );


        }else if($sorting_val == 'price'){

            $params = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'author'            => $author,
                'posts_per_page'    => $per_page,
                'offset'            => $offset,
                'meta_key'          => '_price',
                'orderby'           => 'meta_value_num',
                'order'             => 'ASC',
                'tax_query' => array(
                    array(
                        'taxonomy' => 'product_cat',
                        'field'    => 'term_id',
                        'terms'    => $categories,
                    ),
                ),
            );


        }else if($sorting_val == 'price-desc'){

            $params = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'author'            => $author,
                'posts_per_page'    => $per_page,
                'offset'            => $offset,
                'meta_key'          => '_price',
                'orderby'           => 'meta_value_num',
                'order'             => 'DESC',
                'tax_query' => array(
                    array(
                        'taxonomy' => 'product_cat',
                        'field'    => 'term_id',
                        'terms'    => $categories,
                    ),
                ),
            );


        }else{


            $params = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'author'            => $author,
                'posts_per_page'    => $per_page,
                'offset'            => $offset,
                'orderby'           => $qcld_express_product_sorting,
                'order'             => $qcld_express_product_asc_desc,
                'tax_query' => array(
                    array(
                        'taxonomy' => 'product_cat',
                        'field'    => 'term_id',
                        'terms'    => $categories,
                    ),
                ),
            );

        }



    //Now filtering the categories to pass to query.

   // $params['meta_query'][] = $woocommerce->query->visibility_meta_query();
    //$params['meta_query'][] = $woocommerce->query->stock_status_meta_query();
   
    
    // product search by category ....
    if(isset($_POST['c_id'] )){
        $category=sanitize_text_field($_POST['c_id']);
        if($category=='all'){

          
        }else{
            // $category_sort=array('product_cat' => $category);
            // $params=array_merge($params,$category_sort);

            $params = array(
                'post_type'         => array('product', 'product_variation'),
                'post_status'       => 'publish',
                'author'            => $author,
                'posts_per_page'    => $per_page,
                'offset'            => $offset,
                'orderby'           => $qcld_express_product_sorting,
                'order'             => $qcld_express_product_asc_desc,
                'tax_query' => array(
                    array(
                        'taxonomy' => 'product_cat',
                        'field'    => 'term_id',
                        'terms'    => $category,
                    ),
                ),
            );  


        }
    }



    // order By sku ...
    if(isset($_POST['skuOrder'])){
        $list_order=sanitize_text_field($_POST['skuOrder']);
        //Sku sorting
        if($list_order=='sku_DESC' || $list_order=='sku_ASC'){
            $sku_url=explode("_",$list_order);
            $sku_sort=array('order' =>  $sku_url[1], 
                'orderby' => array('menu_order' => $sku_url[1], 'sku' => $sku_url[1]));
            $params=array_merge($params,$sku_sort);
        }

    }

    // order By Title ...
    if(isset($_POST['titleOrder'])){
        $list_order=sanitize_text_field($_POST['titleOrder']);
        //title sorting
        if($list_order=='title_DESC' || $list_order=='title_ASC'){
            $title_url=explode("_",$list_order);
            $title_sort=array('order' =>  $title_url[1], 
                'orderby' => array('menu_order' => $title_url[1], 'title' => $title_url[1]));
            $params=array_merge($params,$title_sort);
        }

    }

    // order By Price ...
    if(isset($_POST['priceOrder'])){
        $list_order=sanitize_text_field($_POST['priceOrder']);
        //Price sorting
        if($list_order=='price_DESC' || $list_order=='price_ASC'){

            $price_url=explode("_",$list_order);
            $price_sort=array(
                'orderby'   => 'meta_value_num',
                'meta_key'  => '_price',
                'order' => $price_url[1]
            );
            $params=array_merge($params,$price_sort);

        }

    }


    // search form by title...
    if (isset($_POST['title'])) {
        $title=sanitize_text_field($_POST['title']);
        if($title != '') {
        $titleArr = array('s' => $title);
        $params = array_merge($params, $titleArr);
        }
    }
   
    // search form by min price and max price...
    if (isset($_POST['price_min']) || isset($_POST['price_max'])) {
        $price_min = sanitize_text_field($_POST['price_min']);
        $price_max = sanitize_text_field($_POST['price_max']);
        if( $price_min != '' && $price_max == ''){
            $price_min = sanitize_text_field($_POST['price_min']);
            $price_max = sanitize_text_field($_POST['price_min']);
        }else if ($price_min == '' && $price_max != '') {
           $price_min = sanitize_text_field($_POST['price_max']);
           $price_max = sanitize_text_field($_POST['price_max']);
        }else if ($price_min != '' && $price_max != '') {
            $price_min = sanitize_text_field($_POST['price_min']);
            $price_max = sanitize_text_field($_POST['price_max']); 
        }
        if ($price_min != '' && $price_max != '') {
        $priceArr = array(array(
            'key'       => '_price',
            'value'     => array($price_min, $price_max),
            'compare'   => 'BETWEEN',
            'type'      => 'NUMERIC'
        ));

        $params = array_merge($params, array('meta_query' => $priceArr));
        }
    }

    // search form by sku...
    if (isset($_POST['sku'])) {
        $skus=sanitize_text_field($_POST['sku']);
        if ($skus != '') {
        $skuArr = array(array(
            'key'       => '_sku',
            'value'     => $skus,
            'compare'   => 'LIKE'
        ));

        $params = array_merge($params, array('meta_query' => $skuArr));
        }
    }


    /*
        $query = new WP_Query();
        $products = $query->query($params);
    */

    $params['meta_query'] = array();

    // Check products stock status
    $params['meta_query'] = $woocommerce->query->visibility_meta_query();
    $params['meta_query'] = $woocommerce->query->stock_status_meta_query();



    $qcld_express_out_of_stock= isset($qcld_express_options['qcld_express_out_of_stock']) ? $qcld_express_options['qcld_express_out_of_stock'] : '';

    if($qcld_express_out_of_stock == 'on'){

        $params = array_merge($params, array( 'meta_query' => array(
                    array(
                        'key'       => '_stock_status',
                        'value'     => 'instock',
                    ),
                )));

    }

   $product_query = new WP_Query($params);
   $query = new WP_Query();
   $productss = $query->query($params);

    $products_num = count($productss);
    
    if ($products_num == $per_page) {
        $nextOffset = intval($offset + $per_page);
    } else {
        $nextOffset = -1;
    }
    //Creating WooCommerce product factory.
    $wc_pf = new WC_Product_Factory();
    $html = '';
    $counter = 0;
    $qcld_express_slope_type = 'left';
        $html .= '<div class="qcld-express-row qcld_header">';
         //Sku show or not
        if(isset($qcld_express_sku) && $qcld_express_sku=='on' ){
             
            $html .='<div class="qcld-express-cell qcld-express-sku-cell">
            <p class="qcld-express-sku-heading"> <a id="sku-sort" ';
            if(isset($_POST['skuOrder'])){
                if($_POST['skuOrder'] == 'sku_ASC'){
                    $html .=' category_ids="'.$category_ids_perameter.'" audio_feature="'.$qcld_express_audio_feature_product.'" video_feature="'.$qcld_express_video_feature_product.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_sku="sku_DESC" href="#"> '.$qcld_express_lang_sku.' </a> </p>';   
                }
                if($_POST['skuOrder'] == 'sku_DESC'){
                    $html .=' category_ids="'.$category_ids_perameter.'" audio_feature="'.$qcld_express_audio_feature_product.'" video_feature="'.$qcld_express_video_feature_product.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_sku="sku_ASC" href="#"> '.$qcld_express_lang_sku.' </a> </p>';   
                }
            }else{
                    $html .=' category_ids="'.$category_ids_perameter.'" audio_feature="'.$qcld_express_audio_feature_product.'" video_feature="'.$qcld_express_video_feature_product.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_sku="sku_ASC" href="#"> '.$qcld_express_lang_sku.' </a> </p>';
            }
            $html .='';
            if(!isset($_GET['category'] )){
                if(isset($_POST['sku'])){
                    $sku=sanitize_text_field($_POST['sku']);
                }else{
                    $sku="";
                }

                if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){

                    $html .=' <input type="text" name="sku" id="qcld_sku" value="'.$sku.'" placeholder="'.$qcld_express_lang_sku_placeholder.'">';
                }

            }
                $html .='</div>';
        } 

         //Image thumnail show or not
        if(isset($qcld_express_thumbnail) && $qcld_express_thumbnail=='on' ){
      
            $html .='<div class="qcld-express-cell qcld-express-thumb-cell">
                <p class="qcld-express-thumbnail-heading">'.$qcld_express_lang_thumbnail.'</p>
                </div>';
        }
         //Title show or not
        if(isset($qcld_express_title) && $qcld_express_title=='on' ){
    
            $html .='<div class="qcld-express-cell qcld-express-title-cell">
            <p class="qcld-express-title-heading"> <a id="title-sort" ';
            if(isset($_POST['titleOrder'])){
                if($_POST['titleOrder'] == 'title_ASC'){
                    $html .=' category_ids="'.$category_ids_perameter.'" audio_feature="'.$qcld_express_audio_feature_product.'" video_feature="'.$qcld_express_video_feature_product.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_title="title_DESC" href="#">'.$qcld_express_lang_title.' </a> </p>';   
                }
                if($_POST['titleOrder'] == 'title_DESC'){
                    $html .=' category_ids="'.$category_ids_perameter.'" audio_feature="'.$qcld_express_audio_feature_product.'" video_feature="'.$qcld_express_video_feature_product.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_title="title_ASC" href="#">'.$qcld_express_lang_title.' </a> </p>';   
                }
            }else{
                    $html .=' category_ids="'.$category_ids_perameter.'" audio_feature="'.$qcld_express_audio_feature_product.'" video_feature="'.$qcld_express_video_feature_product.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_title="title_ASC" href="#">'.$qcld_express_lang_title.' </a> </p>';
            }
            $html .='';
            if(!isset($_GET['category'] )){
                if(isset($_POST['title'])){
                    $title=sanitize_text_field($_POST['title']);
                }else{
                    $title="";
                }
                if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){
                    
                    $html .=' <div class="qcld-express-search-form-wrapper">
                <form method="get" class="qcld_express_searchform" action="'.esc_url(home_url('/')).'" role="search">
                    <div class="qcld_express_search_products">';
                        $html .=' <input type="text" name="title" id="qcld_title" value="'.$title.'" author="'.$author.'" placeholder="'.$qcld_express_lang_title_placeholder.'" autocomplete="off">';
                    $html .=' </div></form></div>';

                }
            } 
            $html .='</div>';
        }

        //Description show or not
        if(isset($qcld_express_description) && $qcld_express_description=='on' ){
     
            $html .='<div class="qcld-express-cell qcld-express-desc-cell">
                <p class="qcld-express-desc-heading"> '.$qcld_express_lang_desc.' </p>
                </div>';
        }

        //Tag show or not
        if(isset($qcld_express_tag) && $qcld_express_tag=='on' ){
     
            $html .='<div class="qcld-express-cell qcld-express-audio-cell">
                <p class="qcld-express-audio-heading"> '.$qcld_express_tag_lang.' </p>
                </div>';
        }

        //Audio show or not
        if(isset($qcld_express_audio_feature_product) && $qcld_express_audio_feature_product=='on' ){
      
        $html .='<div class="qcld-express-cell qcld-express-audio-cell">
            <p class="qcld-express-audio-heading"> Audio</p>
        </div>';
        }

        //Video show or not
        if(isset($qcld_express_video_feature_product) && $qcld_express_video_feature_product=='on' ){
       
            $html .='<div class="qcld-express-cell qcld-express-video-cell">
                <p class="qcld-express-video-heading"> Video </p>
                </div>';
        }

        //Availability show or not
        if(isset($qcld_express_stock) && $qcld_express_stock=='on' ){
      
            $html .='<div class="qcld-express-cell qcld-express-avail-cell">
                <p class="qcld-express-avail-heading">'.$qcld_express_lang_availability.'</p>
                </div>';
        }

        //Price show or not
        if(isset($qcld_express_price) && $qcld_express_price=='on' ){
     
            $html .='<div class="qcld-express-cell qcld-express-price-cell">
          <p class="qcld-express-price-heading"><a id="price-sort" ';
            if(isset($_POST['priceOrder'])){
                if($_POST['priceOrder'] == 'price_ASC'){
                    $html .=' category_ids="'.$category_ids_perameter.'" audio_feature="'.$qcld_express_audio_feature_product.'" video_feature="'.$qcld_express_video_feature_product.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_price="price_DESC"href="#"> '.$qcld_express_lang_price.' </a> </p>';   
                }
                if($_POST['priceOrder'] == 'price_DESC'){
                    $html .=' category_ids="'.$category_ids_perameter.'" audio_feature="'.$qcld_express_audio_feature_product.'" video_feature="'.$qcld_express_video_feature_product.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_price="price_ASC" href="#"> '.$qcld_express_lang_price.' </a> </p>';   
                }
            }else{
                    $html .=' category_ids="'.$category_ids_perameter.'" audio_feature="'.$qcld_express_audio_feature_product.'" video_feature="'.$qcld_express_video_feature_product.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_price="price_ASC" href="#"> '.$qcld_express_lang_price.' </a> </p>';
            }
            $html .='';
        if(!isset($_GET['category'] )){
            if(isset($_POST['price_min'])){
                $price_min=sanitize_text_field($_POST['price_min']);
            }else{
                $price_min="";
            }
            if(isset($_POST['price_max'])){
                $price_max=sanitize_text_field($_POST['price_max']);
            }else{
                $price_max="";
            }

            if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){
                $html .=' <input type="number" name="price_min" value="'.$price_min.'" id="qcld_price_min" placeholder="'.$qcld_express_lang_from.'" min="0" > - <input type="number" min="0" name="price_max"  value="'.$price_max.'" id="qcld_price_max" placeholder="'.$qcld_express_lang_to.'" >';
            }
        } 
            $html .='</div>';
        }

        // Action show or not
        if(isset($qcld_express_action) && $qcld_express_action=='on' ){

            $html .='<div class="qcld-express-cell qcld-express-action-cell">
          <p class="qcld-express-action-heading">  </p>';
        if(!isset($_GET['category'] )){

            if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){
                $html .='<button type="button" id="submit_search"> '.$qcld_express_lang_search.' </button>';
            }
        }
            $html .='</div>';
        } 

        $html .='</div>';

   // foreach ($products as $P) {
    if ($product_query->have_posts()) :
    while ($product_query->have_posts()) : $product_query->the_post();
     
        $p_ID = get_the_ID();
        $product = $wc_pf->get_product(get_the_ID());
        //var_dump($product);
        //die();
        $getProductDetail = wc_get_product(get_the_ID());
        //Checking for image thumb.
        $qcld_thumb = wp_get_attachment_image_src(get_post_thumbnail_id(get_the_ID()), 'shop_thumbnail');
        $qcld_large = wp_get_attachment_image_src( get_post_thumbnail_id( get_the_ID() ), 'single-post-thumbnail' );
        if (!empty($qcld_thumb)) {
            $image = $qcld_thumb;
            $image_large =$qcld_large;
        } else {
            $image[0] = QCLD_EXPRESS_IMG_URL . '/placeholder.png';
            $image_large[0] = QCLD_EXPRESS_IMG_URL.'/placeholder.png';
        }
        if ($counter % 2 == 0 && $qcld_express_template == "slope") {
            if ($qcld_express_slope_type == 'left') {
                $qcld_express_extra_class = "left-slope";
                $qcld_express_slope_type = 'right';
            } else {
                $qcld_express_extra_class = "right-slope";
                $qcld_express_slope_type = 'left';
            }

        } else {
            $qcld_express_extra_class = "";
        }

        $qcld_express_audio_url     =   unserialize( get_post_meta( get_the_ID(), 'qcld_express_audio_url', true ));
        $audio_not_available = QCLD_EXPRESS_IMG_URL.'/audio-not-available.png';

        $html .= '<div class="qcld-express-row '. $qcld_express_extra_class .'">';
        //SKu show or not
        if (isset($qcld_express_sku) && $qcld_express_sku == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-sku-cell"><p class="qcld-express-sku">'. $product->get_sku() .'</p></div>';
        }
        //Thumbnail show or not
        if (isset($qcld_express_thumbnail) && $qcld_express_thumbnail == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-thumb-cell"><a href="'.$image_large[0].'" class="qcld-express-popup-img"><img class="qlcd-express-list-thumb" src="' . $image[0] . '"  alt="' . get_the_title($p_ID) . '"/></a></div>';
        }

        //Title show or not
        if (isset($qcld_express_title) && $qcld_express_title == 'on') {

            $html .= '<div class="qcld-express-cell qcld-express-title-cell"><h3 class="qcld-express-title">';
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .='<a href="#" class="qcld_express_product_details"  product-id="'.$p_ID.'">' . get_the_title($p_ID) . '</a>';
            }else{ 
            $html .='<a href="'.get_the_permalink($p_ID).'"  product-id="'.$p_ID.'">' . get_the_title($p_ID) . '</a>';
            }

            if(isset($qcld_express_category_show_above_tite) && $qcld_express_category_show_above_tite == 'on' ){
                $html .= '<p class="qcld-express-categorie">'.wc_get_product_category_list($p_ID).'</p>';
            }

            $html .= '</h3></div>';

        }
        //Description show or not
        if (isset($qcld_express_description) && $qcld_express_description == 'on') {

                $html .= '<div class="qcld-express-cell qcld-express-desc-cell"><p class="qcld-express-desc">' . strip_tags(substr(get_the_excerpt($p_ID), 0, $qcld_express_short_description_set_character)) . ' ... ';

             if(isset($qcld_express_details_button) && $qcld_express_details_button == 'on' ){
      
              $html .=  '<a href="#"  class="qcld_express_product_details" product-id="'.$p_ID.'">
                            <i class="fa fa-info-circle" aria-hidden="true"></i>
                        </a>';
            }
           
            $html .='</p></div>';
        }

        //Tag show or not
        if(isset($qcld_express_tag) && $qcld_express_tag == 'on' ){
         
        $html .='<div class="qcld-express-cell qcld-express-desc-cell">';
              $html .='<p class="qcld-express-desc">';
                
                $qcld_output = array();

                $qcld_terms = wp_get_post_terms( $p_ID, 'product_tag' );

                if( count($qcld_terms) > 0 ){
                    foreach($qcld_terms as $term){
                        $term_id = $term->term_id;
                        $term_name = $term->name;
                        $term_slug = $term->slug;
                        $term_link = get_term_link( $term, 'product_tag' );

                        $qcld_output[] = '<a href="'.$term_link.'">'.$term_name.'</a>';
                    }
                    $qcld_output = implode( ', ', $qcld_output );

                    $html .= $qcld_output;
                }
                
            $html .='</p></div>';
        }

          //Audio show or not
          if(isset($qcld_express_audio_feature_product) && $qcld_express_audio_feature_product == 'on' ){
       
          $html .='<div class="qcld-express-cell qcld-express-audio-cell">';
            $qcld_express_audio_title     =   unserialize( get_post_meta( $p_ID, 'qcld_express_audio_title', true ));
            $qcld_express_audio_url       =   unserialize( get_post_meta( $p_ID, 'qcld_express_audio_url', true ));

            $video_img              = QCLD_EXPRESS_IMG_URL.'/video-track.png';
            $audio_not_available    = QCLD_EXPRESS_IMG_URL.'/audio-not-available.png';
               
            if( !empty( $qcld_express_audio_url ) ){
                foreach( $qcld_express_audio_url as $index => $audio_url ){
            if(isset($audio_url) && !empty($audio_url)){
                $qcld_express_audio_title = isset($qcld_express_audio_title[$index]) ? $qcld_express_audio_title[$index] : '';
                $qcld_express_audio_ogg_url = isset($qcld_express_audio_ogg_url[$index]) ? $qcld_express_audio_ogg_url[$index] : '';
            
            $html .='<div class="qcld_express_container">';
            $html .='<div class="qcld_express_audio-player">';
              $html .='<div class="qcld_express_buttons"> <span>';
                $html .='<button type="button" class="qcld_express_prev"></button>';
                $html .='<button type="button" class="qcld_express_play"  title="'.esc_attr($qcld_express_audio_title).'"></button>';
                $html .='<button type="button" class="qcld_express_pause"  title="'.esc_attr($qcld_express_audio_title).'"></button>';
                $html .='<button type="button" class="qcld_express_stop"></button>';
                $html .='<button type="button" class="qcld_express_next"></button>';
                $html .='</span> </div>';
              $html .='<div class="clearfix"></div>';
              $html .='<div class="qcld_express_tracker">';
                $html .='<div class="qcld_express_progress-bar"> <span class="qcld_express_progress"></span> </div>';
                $html .='<span class="qcld_express_duration">0:00</span> </div>';
              $html .='<div class="clearfix"></div>';
              $html .='<ul class="qcld_express_playlist qcld_express_hidden">';
                $html .='<li song="'.esc_url( $audio_url ).'" ogg_song="'.esc_url( $qcld_express_audio_ogg_url ).'" cover="cover1.jpg" artist="Linkin Park">'.esc_url( $audio_url ).'</li>';

              $html .='</ul>';
            $html .='</div>';
          $html .='</div>';
                } 
                } 
            } else{

              $html .='<div class="qcld_express_container">';
                $html .='<div class="qcld_express_audio-player">';
                  $html .='<img src="'.esc_url( $audio_not_available ).'">';
                $html .='</div>';
              $html .='</div>';
            }

          $html .='</div>';
          }

            // Video show or not
            if(isset($qcld_express_video_feature_product) && $qcld_express_video_feature_product == 'on' ){
             
              $html .='<div class="qcld-express-cell qcld-express-video-cell">';

                $qcld_express_video_name      =   unserialize( get_post_meta( $p_ID, 'qcld_express_video_name', true ));
                $qcld_express_video_type      =   unserialize( get_post_meta( $p_ID, 'qcld_express_video_type', true ));
                $qcld_express_video_host      =   unserialize( get_post_meta( $p_ID, 'qcld_express_video_host', true ));
                $qcld_express_video_url       =   unserialize( get_post_meta( $p_ID, 'qcld_express_video_url', true ));

              
                $video_img = QCLD_EXPRESS_IMG_URL.'/video-track.png';
                $audio_not_available = QCLD_EXPRESS_IMG_URL.'/audio-not-available.png';
                   
                if( !empty( $qcld_express_video_name ) ){
                foreach( $qcld_express_video_name as $index => $video_name ){ 
                
                    if(isset($video_name) &&  !empty( $video_name ) ){
                        $qcld_express_video_type = isset($qcld_express_video_type[$index]) ? $qcld_express_video_type[$index] : '';
                        $qcld_express_video_url = isset($qcld_express_video_url[$index]) ? $qcld_express_video_url[$index] : '';
                        $qcld_express_video_host = isset($qcld_express_video_host[$index]) ? $qcld_express_video_host[$index] : '';
               
                $html .='<div class="qcld_express_container">';
                $html .='<div class="qcld_express_audio-player">';
                
                  $html .='<a href="#" class="qcld_express_video_modal" video-type="'.esc_attr($qcld_express_video_type).'" video-host="'.esc_attr($qcld_express_video_host).'" video-url="'.$qcld_express_video_url.'" ><img src="'.esc_url( $video_img ).'" alt="'.esc_attr( $video_name ).'" title="'.esc_attr( $video_name ).'"></a>';
                $html .='</div>';
                $html .='</div>';
                }
                }
                }else{ 
                  $html .='<div class="qcld_express_container">';
                    $html .='<div class="qcld_express_audio-player">';
                      $html .='<img src="'.esc_url( $audio_not_available ).'">';
                    $html .='</div>';
                  $html .='</div>';
                 } 

              $html .='</div>';
            }
          
        //Availability show or not
        if (isset($qcld_express_stock) && $qcld_express_stock == 'on') {
            $stock = get_post_meta( $p_ID, '_stock', true );
            $html .= '<div class="qcld-express-cell qcld-express-avail-cell"><p class="qcld-express-avail">';
           
            if ($stock > 0) {
                $html .= '<span class="qcld-express-avail-in"> '.$qcld_express_lang_in_stock.' (' . $product->get_stock_quantity() . ')</span>';
            } else if($stock=='') {
                $stock_status = get_post_meta( $p_ID, '_stock_status', true );
                if( $stock_status == "instock" ){ 
                    $html .= '<span class="qcld-express-avail-out"> '.$qcld_express_lang_in_stock.' </span>';
                }else if( $stock_status == "outofstock" ){
                    $html .= '<span class="qcld-express-avail-outs"> '.$qcld_express_lang_out_of_stock.' </span>';
                } 
            }else if($stock<0) {
                $html .= '<span class="qcld-express-avail-out"> '.$qcld_express_lang_out_of_stock.'</span>';
            }
            $html .= '</p></div>';
        }


        //Price show or not
        if (isset($qcld_express_price) && $qcld_express_price == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-price-cell"><p class="qcld-express-price">' . $product->get_price_html() . '</p></div>';
        }
        // Action show or not
        if (isset($qcld_express_action) && $qcld_express_action == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-action-cell"><ul class="qcld-express-action">';
            
            if ($product->get_type() == 'simple') {

                $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                    $response_min_max = qcld_express_pro_add_rules_text($p_ID,0);

                    $min_qty  = $response_min_max['min'];
                    $max_qty  = $response_min_max['max'];
                    $step_qty = $response_min_max['step'];
        
    
                    $html.='<li><input type="number" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'" name="qcld_quantity" class="qcld-express-simple-p-qnty"></li>';
                }else{
                $html.='<li><input type="number" value="1" name="qcld_quantity" class="qcld-express-simple-p-qnty"></li>';
                } 
                

              $stock = get_post_meta( $p_ID, '_stock', true );
              $stock_status = get_post_meta( $p_ID, '_stock_status', true );
              if( $stock > 0 ){

                    if (isset($qcld_express_cart_mode) && $qcld_express_cart_mode == 'wooinstants') {
                         $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                            $response_min_max = qcld_express_pro_add_rules_text($p_ID,0);
                            $min_qty  = $response_min_max['min'];
                          }else{
                            $min_qty  = 1;

                          }
                     
                     $html .= ' <li><a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple" data-quantity="'.$min_qty.'" data-product_id="' . $p_ID . '" p-id="' . $p_ID . '" p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }else{
                     $html .= ' <li><a  href="#"  class="qcld_express_s_p" p-id="' . $p_ID . '"p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }

               } else if( $stock == "" ){
               if( $stock_status == "instock" ){
                     if (isset($qcld_express_cart_mode) && $qcld_express_cart_mode == 'wooinstants') {

                         $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                            $response_min_max = qcld_express_pro_add_rules_text($p_ID,0);
                            $min_qty  = $response_min_max['min'];
                          }else{
                            $min_qty  = 1;

                          }
                     
                     $html .= ' <li><a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple" data-quantity="'.$min_qty.'" data-product_id="' . $p_ID . '" p-id="' . $p_ID . '" p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }else{
                     $html .= ' <li><a  href="#"  class="qcld_express_s_p" p-id="' . $p_ID . '"p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }

                } else if( $stock_status == "outofstock" ){ 
                    $html .= ' <li><a href="#" class="qcld_express_out_of_pro" p-id="' . $p_ID . '"p-price="' . $product->get_price() . '" > <i class="fa fa-shopping-cart"></i> </a></li>';

                 } 
                }else if( $stock < 1 ){ 
                     $html .= ' <li><a  href="#"  class="qcld_express_s_p" p-id="' . $p_ID . '"p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';

                } 


            }
            if($product->get_type() == 'external'){

              $link = sprintf( '<a rel="nofollow" href="%s" data-quantity="%s" data-product_id="%s" data-product_sku="%s" class="%s" target="_blank">%s</a>',
                      esc_url( $product->add_to_cart_url() ),
                      esc_attr( isset( $quantity ) ? $quantity : 1 ),
                      esc_attr( $product->get_id() ),
                      esc_attr( $product->get_sku() ),
                      esc_attr( isset( $class ) ? $class : 'qcld_product_type_external' ),
                      esc_html( $product->add_to_cart_text() )
                      );
              $html .= $link;

            }else if ($product->get_type() == 'variable') {
                

              $stock = get_post_meta( $p_ID, '_stock', true );
              $stock_status = get_post_meta( $p_ID, '_stock_status', true );
              if( $stock > 0 ){
                    if($qcld_express_variable_product_show_tooltip == 'on'){
                        $html .= ' <li><a class="qcld_express_v_p_tooltip" p-id="' . $p_ID . '"><i class="fa fa-shopping-cart"></i></a></li>';

                    }else{
                        $html .= ' <li><a class="qcld_express_v_p" p-id="' . $p_ID . '"><i class="fa fa-shopping-cart"></i></a></li>';
                    }

               } else if( $stock == "" ){
               if( $stock_status == "instock" ){
                    if($qcld_express_variable_product_show_tooltip == 'on'){
                        $html .= ' <li><a class="qcld_express_v_p_tooltip" p-id="' . $p_ID . '"><i class="fa fa-shopping-cart"></i></a></li>';

                    }else{
                        $html .= ' <li><a class="qcld_express_v_p" p-id="' . $p_ID . '"><i class="fa fa-shopping-cart"></i></a></li>';
                    }

                } else if( $stock_status == "outofstock" ){ 
                    $html .= ' <li><a href="#" class="qcld_express_out_of_pro" p-id="' . $p_ID . '"><i class="fa fa-shopping-cart"></i></a></li>';

                 } 
                }else if( $stock < 1 ){ 
                    if($qcld_express_variable_product_show_tooltip == 'on'){
                        $html .= ' <li><a class="qcld_express_v_p_tooltip" p-id="' . $p_ID . '"><i class="fa fa-shopping-cart"></i></a></li>';

                    }else{
                        $html .= ' <li><a class="qcld_express_v_p" p-id="' . $p_ID . '"><i class="fa fa-shopping-cart"></i></a></li>';
                    }
                } 

            }

            $html .= '</ul>';


            $qcld_woo_minmax_dynamic_pricing_setting = get_option('qcld_woo_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_minmax_install') && (isset($qcld_woo_minmax_dynamic_pricing_setting['qcld_woo_minmax_price_table_on_off']) && $qcld_woo_minmax_dynamic_pricing_setting['qcld_woo_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_express_pro_dynamic_discount_price_table_show($p_ID);
              $html .= $result_show;
            }

            $html .= '</div>';
        }//End of show or not
        $html .= '</div>';

        //$counter++;
    //} //End of loop

    endwhile;
    wp_reset_postdata();

    else:
        $html .= '<p class="qcld-express-no-products">No Products</p>';
    endif;


    $response = array('offset' => $nextOffset, 'cat_type_id' => $_POST['c_id'],'hot_deail_according_cat' => $hot_deail_according_cat, 'html' => $html);
    echo wp_send_json($response);
    wp_die();

}

// Product Search by category show with category name .....

add_action('wp_ajax_qcld_express_pro_product_search_by_cat_with_cat_name', 'qcld_express_pro_product_search_by_cat_with_cat_name');
add_action('wp_ajax_nopriv_qcld_express_pro_product_search_by_cat_with_cat_name', 'qcld_express_pro_product_search_by_cat_with_cat_name');

function qcld_express_pro_product_search_by_cat_with_cat_name(){

    check_ajax_referer( 'qcld_express_security_nonce', 'security');

    global $woocommerce;

   // Getting option tree from backend.
    $qcld_express_options       = get_option('qcld_express_options');
    $qcld_express_show_mode     = $qcld_express_options['qcld_express_show_mode'];
    $qcld_express_sku           = $qcld_express_options['qcld_express_sku'];
    $qcld_express_thumbnail     = $qcld_express_options['qcld_express_thumbnail'];
    $qcld_express_title         = $qcld_express_options['qcld_express_title'];
    $qcld_express_description   = $qcld_express_options['qcld_express_description'];
    $qcld_express_price         = $qcld_express_options['qcld_express_price'];
    $qcld_express_stock         = $qcld_express_options['qcld_express_stock'];
    $qcld_express_stock_alert   = $qcld_express_options['qcld_express_stock_alert'];
    $qcld_express_action        = $qcld_express_options['qcld_express_action'];
    $qcld_express_background    = $qcld_express_options['qcld_express_background'];
    $qcld_express_altern        = $qcld_express_options['qcld_express_altern'];
    $qcld_express_custom_style  = $qcld_express_options['qcld_express_custom_style'];
    $qcld_express_short_description_set_character        = $qcld_express_options['qcld_express_short_description_set_character'];

    $qcld_express_hide_search_option= $qcld_express_options['qcld_express_hide_search_option'];
    $qcld_express_category_show_above_tite= $qcld_express_options['qcld_express_category_show_below_tite'];

    // Language Change option ... 
    $qcld_express_lang_sku          = $qcld_express_options['qcld_express_lang_sku'];
    $qcld_express_lang_thumbnail    = $qcld_express_options['qcld_express_lang_thumbnail'];
    $qcld_express_lang_title        = $qcld_express_options['qcld_express_lang_title'];
    $qcld_express_lang_desc         = $qcld_express_options['qcld_express_lang_desc'];
    $qcld_express_lang_availability = $qcld_express_options['qcld_express_lang_availability'];
    $qcld_express_lang_price        = $qcld_express_options['qcld_express_lang_price'];
    $qcld_express_lang_action       = $qcld_express_options['qcld_express_lang_action'];
    $qcld_express_lang_search       = $qcld_express_options['qcld_express_lang_search'];
    $qcld_express_lang_cart_summary = $qcld_express_options['qcld_express_lang_cart_summary'];
    $qcld_express_lang_edit_on_cart = $qcld_express_options['qcld_express_lang_edit_on_cart'];
    $qcld_express_lang_checkout     = $qcld_express_options['qcld_express_lang_checkout'];
    $qcld_express_lang_no_products  = $qcld_express_options['qcld_express_lang_no_products'];

        // sorting variables
    $qcld_express_details_button    = $qcld_express_options['qcld_express_details_button'];
    $qcld_express_product_sorting   = $qcld_express_options['qcld_express_product_sorting'];
    $qcld_express_product_asc_desc  = $qcld_express_options['qcld_express_product_asc_desc'];

    $qcld_express_template = $qcld_express_options['qcld_express_template'];

    $qcld_express_product_per_page = $qcld_express_options['qcld_express_product_per_page'];
    if(isset($qcld_express_options['qcld_express_lang_title_placeholder']) && $qcld_express_options['qcld_express_lang_title_placeholder'] !=''){
    $qcld_express_lang_title_placeholder = $qcld_express_options['qcld_express_lang_title_placeholder'];
    }else{
    $qcld_express_lang_title_placeholder = 'Title';

    }

    if(isset($qcld_express_options['qcld_express_lang_sku_placeholder']) && $qcld_express_options['qcld_express_lang_sku_placeholder'] !=''){
    $qcld_express_lang_sku_placeholder = $qcld_express_options['qcld_express_lang_sku_placeholder'];
    }else{
    $qcld_express_lang_sku_placeholder = 'SKU';

    }


    if(isset($qcld_express_options['qcld_express_hot_deals_according_to_cat']) && $qcld_express_options['qcld_express_hot_deals_according_to_cat'] !=''){
    $hot_deail_according_cat = $qcld_express_options['qcld_express_hot_deals_according_to_cat'];
    }else{
    $hot_deail_according_cat = '';
    //hot_deail_according_cat qcld_express_hot_deals_according_to_cat
    }
    if(isset($qcld_express_options['qcld_express_lang_in_stock']) && $qcld_express_options['qcld_express_lang_in_stock'] !=''){
    $qcld_express_lang_in_stock = $qcld_express_options['qcld_express_lang_in_stock'];
    }else{
    $qcld_express_lang_in_stock = 'In Stock';
    }
    if(isset($qcld_express_options['qcld_express_lang_out_of_stock']) && $qcld_express_options['qcld_express_lang_out_of_stock'] !=''){
    $qcld_express_lang_out_of_stock = $qcld_express_options['qcld_express_lang_out_of_stock'];
    }else{
    $qcld_express_lang_out_of_stock = 'Out of Stock';
    }
    if(isset($qcld_express_options['qcld_express_lang_from']) && $qcld_express_options['qcld_express_lang_from'] !=''){
    $qcld_express_lang_from = $qcld_express_options['qcld_express_lang_from'];
    }else{
    $qcld_express_lang_from = 'Form';
    }
    if(isset($qcld_express_options['qcld_express_lang_to']) && $qcld_express_options['qcld_express_lang_to'] !=''){
    $qcld_express_lang_to = $qcld_express_options['qcld_express_lang_to'];
    }else{
    $qcld_express_lang_to = 'To';
    }

    if(isset($qcld_express_options['qcld_express_tag']) && $qcld_express_options['qcld_express_tag'] !=''){
    $qcld_express_tag = $qcld_express_options['qcld_express_tag'];
    }else{
    $qcld_express_tag = 'off';

    }

    if(isset($qcld_express_options['qcld_express_tag_lang']) && $qcld_express_options['qcld_express_tag_lang'] !=''){
    $qcld_express_tag_lang = $qcld_express_options['qcld_express_tag_lang'];
    }else{
    $qcld_express_tag_lang = 'Tag';

    }


    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }

    $audio_feature         = $_POST['audio_feature'];
    $video_feature         = $_POST['video_feature'];
    $author                = $_POST['author'];
    // checking audio feature with shortcode enable
    if(!empty($audio_feature) && $audio_feature == 'on'){
        $qcld_express_audio_feature_product  = $audio_feature;
    }elseif(!empty($audio_feature) && $audio_feature == 'off'){
        $qcld_express_audio_feature_product  = $audio_feature;
    }else{
        $qcld_express_audio_feature_product  = $qcld_express_options['qcld_express_audio_feature_product'];
    }

    // checking audio feature with shortcode enable
    if(!empty($video_feature) && $video_feature == 'on'){
        $qcld_express_video_feature_product  = $video_feature;
    }elseif(!empty($video_feature) && $video_feature == 'off'){
        $qcld_express_video_feature_product  = $video_feature;
    }else{
        $qcld_express_video_feature_product  = $qcld_express_options['qcld_express_video_feature_product'];
    }


    $qcld_express_cart_mode  = $qcld_express_options['qcld_express_cart_mode'];


    $offset=$per_page=-1;


    $category_ids = $_POST['category_ids'];

    // Create query arguments array

    if ($category_ids != '') {
        // if shortcode define category then work here...
        $category_ids = $category_ids;
        $category_ids_perameter = $category_ids;
        $qcld_express_categories = explode(',', $category_ids);

         //Now filtering the categories to pass to query.
        
        $terms = get_terms( array(
            'taxonomy' => 'product_cat',
            'hide_empty' => false,
        ) );

        $categories=array();
        foreach ($terms as $term){
            if(in_array($term->term_id, $qcld_express_categories)){
                array_push($categories,$term->term_id);
            }
        }

    }else{
        // if admin define category then work here...
        if (isset($qcld_express_options['qcld_express_category'])) {
            $qcld_express_categories = $qcld_express_options['qcld_express_category'];
        } else {
            $qcld_express_categories = array();
        }

       
        $terms = get_terms( array(
            'taxonomy' => 'product_cat',
            'hide_empty' => false,
        ) );

        $categories=array();
        foreach ($terms as $term){
            if(!in_array($term->term_id, $qcld_express_categories)){
                array_push($categories,$term->term_id);
            }
        }

    }
   
    $nextOffset = -1;
    $link_title_to_modal = isset($_POST['link_title_to_modal']) ? $_POST['link_title_to_modal'] : 0;
    
    //Creating WooCommerce product factory.
    $wc_pf = new WC_Product_Factory();
    $html = '';
    $counter = 0;
    $qcld_express_slope_type = 'left';
        $html .= '<div class="qcld-express-row qcld_header">';
         //Sku show or not
        if(isset($qcld_express_sku) && $qcld_express_sku=='on' ){
             
            $html .='<div class="qcld-express-cell qcld-express-sku-cell">
            <p class="qcld-express-sku-heading"> <a id="sku-sort" ';
            if(isset($_POST['skuOrder'])){
                if($_POST['skuOrder'] == 'sku_ASC'){
                    $html .=' title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_sku="sku_DESC" href="#"> '.$qcld_express_lang_sku.' </a> </p>';   
                }
                if($_POST['skuOrder'] == 'sku_DESC'){
                    $html .=' title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_sku="sku_ASC" href="#"> '.$qcld_express_lang_sku.' </a> </p>';   
                }
            }else{
                    $html .=' title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_sku="sku_ASC" href="#"> '.$qcld_express_lang_sku.' </a> </p>';
            }
            $html .='';
            if(!isset($_GET['category'] )){
                if(isset($_POST['sku'])){
                    $sku=sanitize_text_field($_POST['sku']);
                }else{
                    $sku="";
                }

                if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){

                    $html .=' <input type="text" name="sku" id="qcld_sku" value="'.$sku.'" placeholder="'.$qcld_express_lang_sku_placeholder.'">';
                }

            }
                $html .='</div>';
        } 

         //Image thumnail show or not
        if(isset($qcld_express_thumbnail) && $qcld_express_thumbnail=='on' ){
      
            $html .='<div class="qcld-express-cell qcld-express-thumb-cell">
                <p class="qcld-express-thumbnail-heading">'.$qcld_express_lang_thumbnail.'</p>
                </div>';
        }
         //Title show or not
        if(isset($qcld_express_title) && $qcld_express_title=='on' ){
    
            $html .='<div class="qcld-express-cell qcld-express-title-cell">
            <p class="qcld-express-title-heading"> <a id="title-sort" ';
            if(isset($_POST['titleOrder'])){
                if($_POST['titleOrder'] == 'title_ASC'){
                    $html .=' title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_title="title_DESC" href="#">'.$qcld_express_lang_title.' </a> </p>';   
                }
                if($_POST['titleOrder'] == 'title_DESC'){
                    $html .=' title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_title="title_ASC" href="#">'.$qcld_express_lang_title.' </a> </p>';   
                }
            }else{
                    $html .=' title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_title="title_ASC" href="#">'.$qcld_express_lang_title.' </a> </p>';
            }
            $html .='';
            if(!isset($_GET['category'] )){
                if(isset($_POST['title'])){
                    $title=sanitize_text_field($_POST['title']);
                }else{
                    $title="";
                }
                if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){
                    $html .='<div class="qcld-express-search-form-wrapper">
                        <form method="get" class="qcld_express_searchform" action="'.esc_url(home_url('/')).'" role="search">
                            <div class="qcld_express_search_products">';
                    $html .=' <input type="text" name="title" id="qcld_title" value="'.$title.'" author="'.$author.'" placeholder="'.$qcld_express_lang_title_placeholder.'" autocomplete="off">';
                    $html .=' </div></form></div>';
                }
            } 
            $html .='</div>';
        }

        //Description show or not
        if(isset($qcld_express_description) && $qcld_express_description=='on' ){
     
            $html .='<div class="qcld-express-cell qcld-express-desc-cell">
                <p class="qcld-express-desc-heading"> '.$qcld_express_lang_desc.' </p>
                </div>';
        }

        //Tag show or not
        if(isset($qcld_express_tag) && $qcld_express_tag=='on' ){
     
            $html .='<div class="qcld-express-cell qcld-express-audio-cell">
                <p class="qcld-express-audio-heading"> '.$qcld_express_tag_lang.' </p>
                </div>';
        }

        //Audio show or not
        if(isset($qcld_express_audio_feature_product) && $qcld_express_audio_feature_product=='on' ){
      
        $html .='<div class="qcld-express-cell qcld-express-audio-cell">
            <p class="qcld-express-audio-heading"> Audio</p>
        </div>';
        }

        //Video show or not
        if(isset($qcld_express_video_feature_product) && $qcld_express_video_feature_product=='on' ){
       
            $html .='<div class="qcld-express-cell qcld-express-video-cell">
                <p class="qcld-express-video-heading"> Video </p>
                </div>';
        }

        //Availability show or not
        if(isset($qcld_express_stock) && $qcld_express_stock=='on' ){
      
            $html .='<div class="qcld-express-cell qcld-express-avail-cell">
                <p class="qcld-express-avail-heading">'.$qcld_express_lang_availability.'</p>
                </div>';
        }

        //Price show or not
        if(isset($qcld_express_price) && $qcld_express_price=='on' ){
     
            $html .='<div class="qcld-express-cell qcld-express-price-cell">
          <p class="qcld-express-price-heading"><a id="price-sort" ';
            if(isset($_POST['priceOrder'])){
                if($_POST['priceOrder'] == 'price_ASC'){
                    $html .=' title-modal="'.$link_title_to_modal.'" author="'.$author.'"order_by_price="price_DESC" href="#"> '.$qcld_express_lang_price.' </a> </p>';   
                }
                if($_POST['priceOrder'] == 'price_DESC'){
                    $html .=' title-modal="'.$link_title_to_modal.'" author="'.$author.'"order_by_price="price_ASC" href="#"> '.$qcld_express_lang_price.' </a> </p>';   
                }
            }else{
                    $html .=' title-modal="'.$link_title_to_modal.'" author="'.$author.'"order_by_price="price_ASC" href="#"> '.$qcld_express_lang_price.' </a> </p>';
            }
            $html .='';
        if(!isset($_GET['category'] )){
            if(isset($_POST['price_min'])){
                $price_min=sanitize_text_field($_POST['price_min']);
            }else{
                $price_min="";
            }
            if(isset($_POST['price_max'])){
                $price_max=sanitize_text_field($_POST['price_max']);
            }else{
                $price_max="";
            }

            if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){
                $html .=' <input type="number" name="price_min" value="'.$price_min.'" id="qcld_price_min" placeholder="'.$qcld_express_lang_from.'" min="0" > - <input type="number" min="0" name="price_max"  value="'.$price_max.'" id="qcld_price_max" placeholder="'.$qcld_express_lang_to.'" >';
            }
        } 
            $html .='</div>';
        }

        // Action show or not
        if(isset($qcld_express_action) && $qcld_express_action=='on' ){

            $html .='<div class="qcld-express-cell qcld-express-action-cell">
          <p class="qcld-express-action-heading">  </p>';
        if(!isset($_GET['category'] )){

            if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){
                $html .='<button type="button" id="submit_search"> '.$qcld_express_lang_search.' </button>';
            }
        }
            $html .='</div>';
        } 

        $html .='</div>';

         $argsss = array(
        'hide_empty' => false,
        'include'    => $categories
      );

        $categoriess = get_terms( 'product_cat', $argsss );

         if (!empty($categoriess)):
          foreach ($categoriess as $category):
              $args = [
                  'post_type'       => array('product', 'product_variation'),
                  'author'          => $author,
                  'posts_per_page'  => -1,
                  'orderby'         => $qcld_express_product_sorting,
                  'order'           => $qcld_express_product_asc_desc,
                  'cat'             => $category->term_id
              ];

             $html .='<div class="qcld-express-row qcld-express-colspan">
                        <div class="qcld-express-category">
                        <a class="qcld-express-active-category  qcld-express-category-title qcld_express_c_search" c-id="'.$category->name.'" audio_feature="'.$qcld_express_audio_feature_product.'" video_feature="'.$qcld_express_video_feature_product.'" author="'.$author.'" data-offset="0" href="#">'.$category->name.'</a>
                        <a class="qcld-express-active-category qcld-express-category-description qcld_express_c_search" c-id="'.$category->name.'" audio_feature="'.$qcld_express_audio_feature_product.'" video_feature="'.$qcld_express_video_feature_product.'" author="'.$author.'" data-offset="0" href="#"> '.strip_tags(substr($category->description,0,150)).'</a>
                        </div>
                    </div>';

      $argss = array(
            'post_type' => 'product',
            'author'          => $author,
            'posts_per_page' => -1,
            'orderby'    => $qcld_express_product_sorting,
            'order'      => $qcld_express_product_asc_desc,
            'tax_query' => array(
                'relation' => 'AND',
                array(
                    'taxonomy' => 'product_cat',
                    'field' => 'slug',
                    'terms' => $category->slug
                )
            ),
        );


    //Now filtering the categories to pass to query.
   

   
    // Calculating nextoffset to show button or not.
    // $products = get_posts($params);

    $querys = new WP_Query();
    $productss = $querys->query($argss);

    foreach ($productss as $P) {
        $product = $wc_pf->get_product($P->ID);
        $getProductDetail = wc_get_product($P->ID);
        //Checking for image thumb.
        $qcld_thumb = wp_get_attachment_image_src(get_post_thumbnail_id($P->ID), 'shop_thumbnail');
        $qcld_large = wp_get_attachment_image_src( get_post_thumbnail_id( $P->ID ), 'single-post-thumbnail' );
        if (!empty($qcld_thumb)) {
            $image = $qcld_thumb;
            $image_large =$qcld_large;
        } else {
            $image[0] = QCLD_EXPRESS_IMG_URL . '/placeholder.png';
            $image_large[0]=QCLD_EXPRESS_IMG_URL.'/placeholder.png';
        }
        if ($counter % 2 == 0 && $qcld_express_template == "slope") {
            if ($qcld_express_slope_type == 'left') {
                $qcld_express_extra_class = "left-slope";
                $qcld_express_slope_type = 'right';
            } else {
                $qcld_express_extra_class = "right-slope";
                $qcld_express_slope_type = 'left';
            }

        } else {
            $qcld_express_extra_class = "";
        }

        $html .= '<div class="qcld-express-row '. $qcld_express_extra_class .'">';
        //SKu show or not
        if (isset($qcld_express_sku) && $qcld_express_sku == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-sku-cell"><p class="qcld-express-sku">'. $product->get_sku() .'</p></div>';
        }
        //Thumbnail show or not
        if (isset($qcld_express_thumbnail) && $qcld_express_thumbnail == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-thumb-cell"><img class="qlcd-express-list-thumb" src="' . $image[0] . '"  alt="' . get_the_title($P->ID) . '"/></div>';


        }
        //Title show or not
        if (isset($qcld_express_title) && $qcld_express_title == 'on') {

            $html .= '<div class="qcld-express-cell qcld-express-title-cell"><h3 class="qcld-express-title">';
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .='<a href="#" class="qcld_express_product_details"  product-id="'.$P->ID.'">' . get_the_title($P->ID) . '</a>';
            }else{ 
            $html .='<a href="'.get_the_permalink($P->ID).'"  product-id="'.$P->ID.'">' . get_the_title($P->ID) . '</a>';
            }

            if(isset($qcld_express_category_show_above_tite) && $qcld_express_category_show_above_tite == 'on' ){
                $html .= '<p class="qcld-express-categorie">'.wc_get_product_category_list($P->ID).'</p>';
            }

            $html .= '</h3></div>';

        }
        //Description show or not
        if (isset($qcld_express_description) && $qcld_express_description == 'on') {

                $html .= '<div class="qcld-express-cell qcld-express-desc-cell"><p class="qcld-express-desc">' . strip_tags(substr(get_the_excerpt($P->ID), 0, $qcld_express_short_description_set_character)) . ' ... ';

             if(isset($qcld_express_details_button) && $qcld_express_details_button == 'on' ){
      
              $html .='<a href="#"  class="qcld_express_product_details" product-id="'.$P->ID.'">
                  <i class="fa fa-info-circle" aria-hidden="true"></i>
              </a>';
            }
           
            $html .='</p></div>';
        }

        //Tag show or not
        if(isset($qcld_express_tag) && $qcld_express_tag == 'on' ){
         
        $html .='<div class="qcld-express-cell qcld-express-desc-cell">';
              $html .='<p class="qcld-express-desc">';
                
                $qcld_output = array();

                $qcld_terms = wp_get_post_terms( $P->ID, 'product_tag' );

                if( count($qcld_terms) > 0 ){
                    foreach($qcld_terms as $term){
                        $term_id = $term->term_id;
                        $term_name = $term->name;
                        $term_slug = $term->slug;
                        $term_link = get_term_link( $term, 'product_tag' );

                        $qcld_output[] = '<a href="'.$term_link.'">'.$term_name.'</a>';
                    }
                    $qcld_output = implode( ', ', $qcld_output );

                    $html .= $qcld_output;
                }
                
            $html .='</p></div>';
        }
        

          //Audio show or not
          if(isset($qcld_express_audio_feature_product) && $qcld_express_audio_feature_product == 'on' ){
       
          $html .='<div class="qcld-express-cell qcld-express-audio-cell">';

            
            $qcld_express_audio_title   =   unserialize( get_post_meta( $p->ID, 'qcld_express_audio_title', true ));
            $qcld_express_audio_url     =   unserialize( get_post_meta( $P->ID, 'qcld_express_audio_url', true ));

                $video_img = QCLD_EXPRESS_IMG_URL.'/video-track.png';
                $audio_not_available = QCLD_EXPRESS_IMG_URL.'/audio-not-available.png';
               
            if( !empty( $qcld_express_audio_url ) ){
                foreach( $qcld_express_audio_url as $index => $audio_url ){
                    if(isset($audio_url) && !empty($audio_url)){
                        $qcld_express_audio_title = isset($qcld_express_audio_title[$index]) ? $qcld_express_audio_title[$index] : '';
                        $qcld_express_audio_ogg_url = isset($qcld_express_audio_ogg_url[$index]) ? $qcld_express_audio_ogg_url[$index] : '';
            
            $html .='<div class="qcld_express_container">';
            $html .='<div class="qcld_express_audio-player">';
              $html .='<div class="qcld_express_buttons"> <span>';
                $html .='<button type="button" class="qcld_express_prev"></button>';
                $html .='<button type="button" class="qcld_express_play" title="'.esc_attr( $qcld_express_audio_title ).'"></button>';
                $html .='<button type="button" class="qcld_express_pause" title="'.esc_attr( $qcld_express_audio_title ).'"></button>';
                $html .='<button type="button" class="qcld_express_stop"></button>';
                $html .='<button type="button" class="qcld_express_next"></button>';
                $html .='</span> </div>';
              $html .='<div class="clearfix"></div>';
              $html .='<div class="qcld_express_tracker">';
                $html .='<div class="qcld_express_progress-bar"> <span class="qcld_express_progress"></span> </div>';
                $html .='<span class="qcld_express_duration">0:00</span> </div>';
              $html .='<div class="clearfix"></div>';
              $html .='<ul class="qcld_express_playlist qcld_express_hidden">';
                $html .='<li song="'.esc_url( $audio_url ).'" ogg_song="'.esc_url( $qcld_express_audio_ogg_url ).'" cover="cover1.jpg" artist="Linkin Park">'.esc_url( $audio_url ).'</li>';
              $html .='</ul>';
            $html .='</div>';
          $html .='</div>';
                }  } 
            } else{

                  $html .='<div class="qcld_express_container">';
                    $html .='<div class="qcld_express_audio-player">';
                      $html .='<img src="'.esc_url( $audio_not_available ).'">';
                    $html .='</div>';
                  $html .='</div>';
            }

          $html .='</div>';
          }

            // Video show or not
            if(isset($qcld_express_video_feature_product) && $qcld_express_video_feature_product == 'on' ){
             
              $html .='<div class="qcld-express-cell qcld-express-video-cell">';

                $qcld_express_video_name      =   unserialize( get_post_meta( $P->ID, 'qcld_express_video_name', true ));
                $qcld_express_video_type      =   unserialize( get_post_meta( $P->ID, 'qcld_express_video_type', true ));
                $qcld_express_video_host      =   unserialize( get_post_meta( $P->ID, 'qcld_express_video_host', true ));
                $qcld_express_video_url       =   unserialize( get_post_meta( $P->ID, 'qcld_express_video_url', true ));

              
                $video_img = QCLD_EXPRESS_IMG_URL.'/video-track.png';
                $audio_not_available = QCLD_EXPRESS_IMG_URL.'/audio-not-available.png';
                   
                if( !empty( $qcld_express_video_name ) ){
                foreach( $qcld_express_video_name as $index => $video_name ){ 
                
                    if(isset($video_name) &&  !empty( $video_name ) ){
                        $qcld_express_video_type = isset($qcld_express_video_type[$index]) ? $qcld_express_video_type[$index] : '';
                        $qcld_express_video_url = isset($qcld_express_video_url[$index]) ? $qcld_express_video_url[$index] : '';
                        $qcld_express_video_host = isset($qcld_express_video_host[$index]) ? $qcld_express_video_host[$index] : '';
               
               
                $html .='<div class="qcld_express_container">';
                $html .='<div class="qcld_express_audio-player">';


                
                  $html .='<a href="#" class="qcld_express_video_modal" video-type="'.esc_attr($qcld_express_video_type).'" video-host="'.esc_attr($qcld_express_video_host).'" video-url="'.$qcld_express_video_url.'" ><img src="'.esc_url( $video_img ).'" alt="'.esc_attr( $video_name ).'" title="'.esc_attr( $video_name ).'"></a>';
                $html .='</div>';
              $html .='</div>';
                } }
                }else{ 
                  $html .='<div class="qcld_express_container">';
                    $html .='<div class="qcld_express_audio-player">';
                      $html .='<img src="'.esc_url( $audio_not_available ).'">';
                    $html .='</div>';
                  $html .='</div>';
                 } 

              $html .='</div>';
            }
        //Availability show or not
        if (isset($qcld_express_stock) && $qcld_express_stock == 'on') {
            $stock = get_post_meta( $P->ID, '_stock', true );
            $html .= '<div class="qcld-express-cell qcld-express-avail-cell"><p class="qcld-express-avail">';
           
            if ($stock > 0) {
                $html .= '<span class="qcld-express-avail-in"> '.$qcld_express_lang_in_stock.' (' . $product->get_stock_quantity() . ')</span>';
            } else if($stock=='') {
                $stock_status = get_post_meta( $P->ID, '_stock_status', true );
                if( $stock_status == "instock" ){ 
                    $html .= '<span class="qcld-express-avail-out"> '.$qcld_express_lang_in_stock.' </span>';
                }else if( $stock_status == "outofstock" ){
                    $html .= '<span class="qcld-express-avail-outs">'.$qcld_express_lang_out_of_stock.' </span>';
                } 
            }else if($stock<0) {
                $html .= '<span class="qcld-express-avail-out">'.$qcld_express_lang_out_of_stock.'</span>';
            }
            $html .= '</p></div>';
        }


        //Price show or not
        if (isset($qcld_express_price) && $qcld_express_price == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-price-cell"><p class="qcld-express-price">' . $product->get_price_html() . '</p></div>';
        }
        // Action show or not
        if (isset($qcld_express_action) && $qcld_express_action == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-action-cell"><ul class="qcld-express-action">';
            
            if ($product->get_type() == 'simple') {
            
                $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                    $response_min_max = qcld_express_pro_add_rules_text($P->ID,0);

                    $min_qty  = $response_min_max['min'];
                    $max_qty  = $response_min_max['max'];
                    $step_qty = $response_min_max['step'];
    
                    $html.='<li><input type="number" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'" name="qcld_quantity" class="qcld-express-simple-p-qnty"></li>';


                }else{
                $html.='<li><input type="number" value="1" name="qcld_quantity" class="qcld-express-simple-p-qnty"></li>';
                } 
                

              $stock = get_post_meta( $P->ID, '_stock', true );
              $stock_status = get_post_meta( $P->ID, '_stock_status', true );
              if( $stock > 0 ){

                $qcld_express_options   = get_option('qcld_express_options');

                $qcld_express_cart_mode = $qcld_express_options['qcld_express_cart_mode'];

                 if (isset($qcld_express_cart_mode) && $qcld_express_cart_mode == 'wooinstants') {

                         $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                            $response_min_max = qcld_express_pro_add_rules_text($P->ID,0);
                            $min_qty  = $response_min_max['min'];
                          }else{
                            $min_qty  = 1;

                          }
                      
                      $html .= '<li><a href="#" class="ajax_add_to_cart add_to_cart_button product_type_simple" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $P->ID .'" p-id="' . $P->ID .'" p-price="'.$product->get_price().'" ><i class="fa fa-shopping-cart"></i></a></li>';
                      }else{ 


                        $html .= ' <li><a  href="#"  class="qcld_express_s_p" p-id="' . $P->ID . '"p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }

               } else if( $stock == "" ){
               if( $stock_status == "instock" ){


                 if (isset($qcld_express_cart_mode) && $qcld_express_cart_mode == 'wooinstants') {

                         $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                            $response_min_max = qcld_express_pro_add_rules_text($P->ID,0);
                            $min_qty  = $response_min_max['min'];
                          }else{
                            $min_qty  = 1;

                          }
                      
                      $html .= '<li><a href="#" class="ajax_add_to_cart add_to_cart_button product_type_simple" data-quantity="'.($min_qty ? $min_qty : 1).'" data-product_id="' . $P->ID .'" p-id="' . $P->ID .'" p-price="'.$product->get_price().'" ><i class="fa fa-shopping-cart"></i></a></li>';
                      }else{ 
                     $html .= ' <li><a  href="#"  class="qcld_express_s_p" p-id="' . $P->ID . '"p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                 }

                } else if( $stock_status == "outofstock" ){ 
                    $html .= ' <li><a href="#" class="qcld_express_out_of_pro" p-id="' . $P->ID . '"p-price="' . $product->get_price() . '" > <i class="fa fa-shopping-cart"></i> </a></li>';

                 } 
                }else if( $stock < 1 ){ 
                     $html .= ' <li><a  href="#"  class="qcld_express_s_p" p-id="' . $P->ID . '"p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';

                } 


            }
            if($product->get_type() == 'external'){

              $link = sprintf( '<a rel="nofollow" href="%s" data-quantity="%s" data-product_id="%s" data-product_sku="%s" class="%s" target="_blank">%s</a>',
                      esc_url( $product->add_to_cart_url() ),
                      esc_attr( isset( $quantity ) ? $quantity : 1 ),
                      esc_attr( $product->get_id() ),
                      esc_attr( $product->get_sku() ),
                      esc_attr( isset( $class ) ? $class : 'qcld_product_type_external' ),
                      esc_html( $product->add_to_cart_text() )
                      );
              $html .= $link;

            }else if ($product->get_type() == 'variable') {
                
              $stock = get_post_meta( $P->ID, '_stock', true );
              $stock_status = get_post_meta( $P->ID, '_stock_status', true );
              if( $stock > 0 ){
              $html .= ' <li><a href="#" class="qcld_express_v_p" p-id="' . $P->ID . '"><i class="fa fa-shopping-cart"></i></a></li>';

               } else if( $stock == "" ){
               if( $stock_status == "instock" ){
                    $html .= ' <li><a href="#" class="qcld_express_v_p" p-id="' . $P->ID . '"><i class="fa fa-shopping-cart"></i></a></li>';

                } else if( $stock_status == "outofstock" ){ 
                    $html .= ' <li><a href="#" class="qcld_express_out_of_pro" p-id="' . $P->ID . '"><i class="fa fa-shopping-cart"></i></a></li>';

                 } 
                }else if( $stock < 1 ){ 
                    $html .= ' <li><a href="#" class="qcld_express_v_p" p-id="' . $P->ID . '"><i class="fa fa-shopping-cart"></i></a></li>';
                } 

            }

            $html .= '</ul>';

            $qcld_woo_minmax_dynamic_pricing_setting = get_option('qcld_woo_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_minmax_install') && (isset($qcld_woo_minmax_dynamic_pricing_setting['qcld_woo_minmax_price_table_on_off']) && $qcld_woo_minmax_dynamic_pricing_setting['qcld_woo_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_express_pro_dynamic_discount_price_table_show($P->ID);
              $html .= $result_show;
            }
            
            $html .= '</div>';
        }//End of show or not
        $html .= '</div>';


        $counter++;
    } //End of loop
    wp_reset_postdata();
    endforeach;
    wp_reset_postdata();
endif;


    $response = array('offset' => $nextOffset, 'cat_type_id' => $_POST['c_id'], 'hot_deail_according_cat' => $hot_deail_according_cat, 'html' => $html);
    echo wp_send_json($response);

}



// ajax search product .... 
/* Ajax search */
add_action('wp_ajax_qcld_express_pro_shop_ajax_search', 'qcld_express_pro_shop_ajax_search');
add_action('wp_ajax_nopriv_qcld_express_pro_shop_ajax_search', 'qcld_express_pro_shop_ajax_search');
if ( !function_exists('qcld_express_pro_shop_ajax_search') ) {

    function qcld_express_pro_shop_ajax_search() {

        check_ajax_referer( 'qcld_express_security_nonce', 'security');

        global $wpdb, $post;

        if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
            $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
            $rolebased->wc_init();
        }

        $return = array(
            'status' => 'error',
            'html' => ''
        );    
        if( isset( $_REQUEST['s'] ) && $_REQUEST['s'] != '') {    
          
                $taxonomy = 'product_cat';
                $post_type = 'product';
           
            $number = 10;
            $num_result = isset($number) ? (int) $number : 10;
            $query = sanitize_text_field($_REQUEST['s']);
            $author = sanitize_text_field($_REQUEST['author']);
            $args = array(
                'post_type'         => $post_type, 
                'post_status'       => 'publish',
                'author'            => $author,
                's'                 => $query, 
                'posts_per_page'    => $num_result,
                'tax_query'         => array()
            );
            //if ($has_woocommerce) {
                $args['meta_query'] = WC()->query->get_meta_query();
                $args['tax_query'] = WC()->query->get_tax_query();
           // }

            $qcld_express_options           = get_option('qcld_express_options');

            $qcld_express_out_of_stock= isset($qcld_express_options['qcld_express_out_of_stock']) ? $qcld_express_options['qcld_express_out_of_stock'] : '';

            if($qcld_express_out_of_stock == 'on'){

                $args = array_merge($args, array( 'meta_query' => array(
                            array(
                                'key'       => '_stock_status',
                                'value'     => 'instock',
                            ),
                        )));

            }
          
            $results = new WP_Query($args);



            if ($results->have_posts()) {

                $return['status'] = 'success';
                $return['html'] .= '<ul class="qcld-express-list-products">';
                while ($results->have_posts()) {
                 ob_start();
                 $results->the_post();

                 $image = '';
                 if ($post_type == 'product') {
                    $product = wc_get_product($post->ID);
                    $image = $product->get_image();
                } else if (has_post_thumbnail($post->ID)) {
                    $image = get_the_post_thumbnail($post->ID, 'thumbnail');
                }

                $return['html'] .= '<li>';
                $return['html'] .= '<div class="search-form-wrapper-image">';
                $return['html'] .= '<a href="#" class="qcld-express-search-single" p-id="'.$post->ID.'">' . $image . '</a>';
                $return['html'] .= '</div>';
                $return['html'] .= '<div class="search-form-wrapper-meta item-information">';
                $return['html'] .= '<a href="#" p-id="'.$post->ID.'" author="'.$author.'" class="product-title product-name qcld-express-search-single">' . esc_attr($post->post_title) . '</a>';
                if ($post_type == 'product') {
                    if ($price_html = $product->get_price_html()) {
                        $return['html'] .= '<span class="price">' . $price_html . '</span>';
                    }
                }
                $return['html'] .= '</div>';
                $return['html'] .= '</li>';
            }
            $return['html'] .= '</ul>';

            if (isset($results->post_count, $results->found_posts) && $results->found_posts > $results->post_count) {
                $return['status'] = 'error';
                $view_all_text = sprintf(esc_html__('View all %d results', 'express-shop-pro'), $results->found_posts);

            }
            wp_reset_postdata();
        }
        else {
            $return['html'] = '<span class="no-result">'.esc_html__('No matches found.', 'express-shop-pro').'</span>';
            wp_reset_postdata();
        }
    }
    echo json_encode($return);
    die();
    }
} 



//Search product
add_action('wp_ajax_qcld_express_pro_search_product_single_view', 'qcld_express_pro_search_product_single_view');
add_action('wp_ajax_nopriv_qcld_express_pro_search_product_single_view', 'qcld_express_pro_search_product_single_view');

function qcld_express_pro_search_product_single_view(){

    check_ajax_referer( 'qcld_express_security_nonce', 'security');

    global $woocommerce;

   // Getting option tree from backend.
    $qcld_express_options       = get_option('qcld_express_options');
    $qcld_express_show_mode     = $qcld_express_options['qcld_express_show_mode'];
    $qcld_express_cart_mode     = $qcld_express_options['qcld_express_cart_mode'];
    $qcld_express_sku           = $qcld_express_options['qcld_express_sku'];
    $qcld_express_thumbnail     = $qcld_express_options['qcld_express_thumbnail'];
    $qcld_express_title         = $qcld_express_options['qcld_express_title'];
    $qcld_express_description   = $qcld_express_options['qcld_express_description'];
    $qcld_express_price         = $qcld_express_options['qcld_express_price'];
    $qcld_express_stock         = $qcld_express_options['qcld_express_stock'];
    $qcld_express_stock_alert   = $qcld_express_options['qcld_express_stock_alert'];
    $qcld_express_action        = $qcld_express_options['qcld_express_action'];
    $qcld_express_background    = $qcld_express_options['qcld_express_background'];
    $qcld_express_altern        = $qcld_express_options['qcld_express_altern'];
    $qcld_express_custom_style  = $qcld_express_options['qcld_express_custom_style'];
    $qcld_express_short_description_set_character        = $qcld_express_options['qcld_express_short_description_set_character'];

    $qcld_express_hide_search_option= $qcld_express_options['qcld_express_hide_search_option'];
    $qcld_express_category_show_above_tite= $qcld_express_options['qcld_express_category_show_below_tite'];

    // Language Change option ... 
    $qcld_express_lang_sku          = $qcld_express_options['qcld_express_lang_sku'];
    $qcld_express_lang_thumbnail    = $qcld_express_options['qcld_express_lang_thumbnail'];
    $qcld_express_lang_title        = $qcld_express_options['qcld_express_lang_title'];
    $qcld_express_lang_desc         = $qcld_express_options['qcld_express_lang_desc'];
    $qcld_express_lang_availability = $qcld_express_options['qcld_express_lang_availability'];
    $qcld_express_lang_price        = $qcld_express_options['qcld_express_lang_price'];
    $qcld_express_lang_action       = $qcld_express_options['qcld_express_lang_action'];
    $qcld_express_lang_search       = $qcld_express_options['qcld_express_lang_search'];
    $qcld_express_lang_cart_summary = $qcld_express_options['qcld_express_lang_cart_summary'];
    $qcld_express_lang_edit_on_cart = $qcld_express_options['qcld_express_lang_edit_on_cart'];
    $qcld_express_lang_checkout     = $qcld_express_options['qcld_express_lang_checkout'];
    $qcld_express_lang_no_products  = $qcld_express_options['qcld_express_lang_no_products'];

        // sorting variables
    $qcld_express_details_button    = $qcld_express_options['qcld_express_details_button'];
    $qcld_express_product_sorting   = $qcld_express_options['qcld_express_product_sorting'];
    $qcld_express_product_asc_desc  = $qcld_express_options['qcld_express_product_asc_desc'];

    $qcld_express_template = $qcld_express_options['qcld_express_template'];

    $qcld_express_product_per_page = $qcld_express_options['qcld_express_product_per_page'];


    if(isset($qcld_express_options['qcld_express_lang_title_placeholder']) && $qcld_express_options['qcld_express_lang_title_placeholder'] !=''){
    $qcld_express_lang_title_placeholder = $qcld_express_options['qcld_express_lang_title_placeholder'];
    }else{
    $qcld_express_lang_title_placeholder = 'Title';

    }    
    if(isset($qcld_express_options['qcld_express_lang_sku_placeholder']) && $qcld_express_options['qcld_express_lang_sku_placeholder'] !=''){
    $qcld_express_lang_sku_placeholder = $qcld_express_options['qcld_express_lang_sku_placeholder'];
    }else{
    $qcld_express_lang_sku_placeholder = 'SKU';

    }
    if(isset($qcld_express_options['qcld_express_lang_in_stock']) && $qcld_express_options['qcld_express_lang_in_stock'] !=''){
    $qcld_express_lang_in_stock = $qcld_express_options['qcld_express_lang_in_stock'];
    }else{
    $qcld_express_lang_in_stock = 'In Stock';
    }
    if(isset($qcld_express_options['qcld_express_lang_out_of_stock']) && $qcld_express_options['qcld_express_lang_out_of_stock'] !=''){
    $qcld_express_lang_out_of_stock = $qcld_express_options['qcld_express_lang_out_of_stock'];
    }else{
    $qcld_express_lang_out_of_stock = 'Out of Stock';
    }
    if(isset($qcld_express_options['qcld_express_lang_from']) && $qcld_express_options['qcld_express_lang_from'] !=''){
    $qcld_express_lang_from = $qcld_express_options['qcld_express_lang_from'];
    }else{
    $qcld_express_lang_from = 'Form';
    }
    if(isset($qcld_express_options['qcld_express_lang_to']) && $qcld_express_options['qcld_express_lang_to'] !=''){
    $qcld_express_lang_to = $qcld_express_options['qcld_express_lang_to'];
    }else{
    $qcld_express_lang_to = 'To';
    }

    if(isset($qcld_express_options['qcld_express_tag']) && $qcld_express_options['qcld_express_tag'] !=''){
    $qcld_express_tag = $qcld_express_options['qcld_express_tag'];
    }else{
    $qcld_express_tag = 'off';

    }

    if(isset($qcld_express_options['qcld_express_tag_lang']) && $qcld_express_options['qcld_express_tag_lang'] !=''){
    $qcld_express_tag_lang = $qcld_express_options['qcld_express_tag_lang'];
    }else{
    $qcld_express_tag_lang = 'Tag';

    }

    $offset=$_POST['offset'];
    $category_ids=$_POST['category_ids'];
    $link_title_to_modal = $_POST['link_title_to_modal'];
    $p_id = $_POST['p_id'];
    $search_type = $_POST['search_type'];
    $author = $_POST['author'];

    if($qcld_express_show_mode=='more' || $qcld_express_show_mode=='scroll'){
        if($qcld_express_product_per_page != ''){
            $per_page=$qcld_express_product_per_page;
            
        }else{

            $per_page=-1;
        }
    }else{
        $per_page=-1;
    }


    if(class_exists('QCLD_WooCommerce_Role_Based_Price_Product_Pricing')){
        $rolebased = new QCLD_WooCommerce_Role_Based_Price_Product_Pricing(true);
        $rolebased->wc_init();
    }


    //pulling up the product accroding to the query
    // Get WooCommerce Global from Qcld_woo_inc class
    // Create query arguments array
    $category_ids_perameter = '';
     if ($category_ids != '') {
        // if shortcode define category then work here...
        $category_ids = $category_ids;
        $category_ids_perameter = $category_ids;
        $qcld_express_categories = explode(',', $category_ids);

         //Now filtering the categories to pass to query.
        
        $terms = get_terms( array(
            'taxonomy' => 'product_cat',
            'hide_empty' => false,
        ) );

        $categories=array();
        foreach ($terms as $term){
            if(in_array($term->term_id, $qcld_express_categories)){
                array_push($categories,$term->term_id);
            }
        }

    }else{
        // if admin define category then work here...
        if (isset($qcld_express_options['qcld_express_category'])) {
            $qcld_express_categories = $qcld_express_options['qcld_express_category'];
        } else {
            $qcld_express_categories = array();
        }

       
        $terms = get_terms( array(
            'taxonomy' => 'product_cat',
            'hide_empty' => false,
        ) );

        $categories=array();
        foreach ($terms as $term){
            if(!in_array($term->term_id, $qcld_express_categories)){
                array_push($categories,$term->term_id);
            }
        }

    }

        $params = array(
            'post_type'         => array('product', 'product_variation'),
            'post_status'       => 'publish',
            'author'            => $author,
            'posts_per_page'    => $per_page,
            'offset'            => $offset,
            'post__in'          => [$p_id],
            'orderby'           => $qcld_express_product_sorting,
            'order'             => $qcld_express_product_asc_desc,
     
        );     

            // Add meta_query to query args
        $params['meta_query'] = array();

        // Check products stock status
        //$params['meta_query'][] = $woocommerce->query->stock_status_meta_query();

        // Check products stock status
        $params['meta_query'][] = $woocommerce->query->visibility_meta_query();
        $params['meta_query'][] = $woocommerce->query->stock_status_meta_query();

        //Now filtering the categories to pass to query.



        $qcld_express_out_of_stock= isset($qcld_express_options['qcld_express_out_of_stock']) ? $qcld_express_options['qcld_express_out_of_stock'] : '';

        if($qcld_express_out_of_stock == 'on'){

            $params = array_merge($params, array( 'meta_query' => array(
                        array(
                            'key'       => '_stock_status',
                            'value'     => 'instock',
                        ),
                    )));

        }
   

   

    // Calculating nextoffset to show button or not.
    // $products = get_posts($params);

    $query = new WP_Query();
    $products = $query->query($params);

    $products_num = count($products);
    if ($products_num == $per_page) {
        $nextOffset = intval($offset + $per_page);
    } else {
        $nextOffset = -1;
    }
    //Creating WooCommerce product factory.
    $wc_pf = new WC_Product_Factory();
    $html = '';
    $counter = 0;
    $qcld_express_slope_type = 'left';
        $html .= '<div class="qcld-express-row qcld_header">';
         //Sku show or not
        if(isset($qcld_express_sku) && $qcld_express_sku=='on' ){
             
            $html .='<div class="qcld-express-cell qcld-express-sku-cell">
            <p class="qcld-express-sku-heading"> <a id="sku-sort" ';
            if(isset($_POST['skuOrder'])){
                if($_POST['skuOrder'] == 'sku_ASC'){
                    $html .=' category_ids="'.$category_ids_perameter.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_sku="sku_DESC" href="#"> '.$qcld_express_lang_sku.' </a> </p>';   
                }
                if($_POST['skuOrder'] == 'sku_DESC'){
                    $html .=' category_ids="'.$category_ids_perameter.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_sku="sku_ASC" href="#"> '.$qcld_express_lang_sku.' </a> </p>';   
                }
            }else{
                    $html .=' category_ids="'.$category_ids_perameter.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_sku="sku_ASC" href="#"> '.$qcld_express_lang_sku.' </a> </p>';
            }
            $html .='';
            if(!isset($_GET['category'] )){
                if(isset($_POST['sku'])){
                    $sku=sanitize_text_field($_POST['sku']);
                }else{
                    $sku="";
                }

                if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){

                    $html .=' <input type="text" name="sku" id="qcld_sku" value="'.$sku.'" placeholder="'.$qcld_express_lang_sku_placeholder.'">';
                }

            }
                $html .='</div>';
        } 

         //Image thumnail show or not
        if(isset($qcld_express_thumbnail) && $qcld_express_thumbnail=='on' ){
      
            $html .='<div class="qcld-express-cell qcld-express-thumb-cell">
                <p class="qcld-express-thumbnail-heading">'.$qcld_express_lang_thumbnail.'</p>
                </div>';
        }
         //Title show or not
        if(isset($qcld_express_title) && $qcld_express_title=='on' ){
    
            $html .='<div class="qcld-express-cell qcld-express-title-cell">
            <p class="qcld-express-title-heading"> <a id="title-sort" ';
            if(isset($_POST['titleOrder'])){
                if($_POST['titleOrder'] == 'title_ASC'){
                    $html .=' category_ids="'.$category_ids_perameter.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_title="title_DESC" href="#">'.$qcld_express_lang_title.' </a> </p>';   
                }
                if($_POST['titleOrder'] == 'title_DESC'){
                    $html .=' category_ids="'.$category_ids_perameter.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_title="title_ASC" href="#">'.$qcld_express_lang_title.' </a> </p>';   
                }
            }else{
                    $html .=' category_ids="'.$category_ids_perameter.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_title="title_ASC" href="#">'.$qcld_express_lang_title.' </a> </p>';
            }
            $html .='';
            if(!isset($_GET['category'] )){
                if(isset($_POST['title'])){
                    $title=sanitize_text_field($_POST['title']);
                }else{
                    $title="";
                }
                if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){
                    
                    $html .='<div class="qcld-express-search-form-wrapper">
                <form method="get" class="qcld_express_searchform" action="'.esc_url(home_url('/')).'" role="search">
                    <div class="qcld_express_search_products">';
                        $html .=' <input type="text" name="title" id="qcld_title" value="'.$title.'" author="'.$author.'" placeholder="'.$qcld_express_lang_title_placeholder.'" autocomplete="off">';
                    $html .=' </div></form></div>';

                }
            } 
            $html .='</div>';
        }

        //Description show or not
        if(isset($qcld_express_description) && $qcld_express_description=='on' ){
     
            $html .='<div class="qcld-express-cell qcld-express-desc-cell">
                <p class="qcld-express-desc-heading"> '.$qcld_express_lang_desc.' </p>
                </div>';
        }

        //Tag show or not
        if(isset($qcld_express_tag) && $qcld_express_tag=='on' ){
     
            $html .='<div class="qcld-express-cell qcld-express-desc-cell">
                <p class="qcld-express-desc-heading"> '.$qcld_express_tag_lang.' </p>
                </div>';
        }

        //Availability show or not
        if(isset($qcld_express_stock) && $qcld_express_stock=='on' ){
      
            $html .='<div class="qcld-express-cell qcld-express-avail-cell">
                <p class="qcld-express-avail-heading">'.$qcld_express_lang_availability.'</p>
                </div>';
        }

        //Price show or not
        if(isset($qcld_express_price) && $qcld_express_price=='on' ){
     
            $html .='<div class="qcld-express-cell qcld-express-price-cell">
          <p class="qcld-express-price-heading"><a id="price-sort" ';
            if(isset($_POST['priceOrder'])){
                if($_POST['priceOrder'] == 'price_ASC'){
                    $html .=' category_ids="'.$category_ids_perameter.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_price="price_DESC" href="#"> '.$qcld_express_lang_price.' </a> </p>';   
                }
                if($_POST['priceOrder'] == 'price_DESC'){
                    $html .=' category_ids="'.$category_ids_perameter.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_price="price_ASC" href="#"> '.$qcld_express_lang_price.' </a> </p>';   
                }
            }else{
                    $html .=' category_ids="'.$category_ids_perameter.'" title-modal="'.$link_title_to_modal.'" author="'.$author.'" order_by_price="price_ASC" href="#"> '.$qcld_express_lang_price.' </a> </p>';
            }
            $html .='';
        if(!isset($_GET['category'] )){
            if(isset($_POST['price_min'])){
                $price_min=sanitize_text_field($_POST['price_min']);
            }else{
                $price_min="";
            }
            if(isset($_POST['price_max'])){
                $price_max=sanitize_text_field($_POST['price_max']);
            }else{
                $price_max="";
            }

            if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){
                $html .=' <input type="number" name="price_min" value="'.$price_min.'" id="qcld_price_min" placeholder="'.$qcld_express_lang_from.'" min="0" > - <input type="number" min="0" name="price_max"  value="'.$price_max.'" id="qcld_price_max" placeholder="'.$qcld_express_lang_to.'" >';
            }
        } 
            $html .='</div>';
        }

        // Action show or not
        if(isset($qcld_express_action) && $qcld_express_action=='on' ){

            $html .='<div class="qcld-express-cell qcld-express-action-cell">
          <p class="qcld-express-action-heading">  </p>';
        if(!isset($_GET['category'] )){

            if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){
                $html .='<button type="button" id="submit_search"> '.$qcld_express_lang_search.' </button>';
            }
        }
            $html .='</div>';
        } 

        $html .='</div>';

    foreach ($products as $P) {
        $product = $wc_pf->get_product($P->ID);
        $getProductDetail = wc_get_product($P->ID);
        //Checking for image thumb.
        $qcld_thumb = wp_get_attachment_image_src(get_post_thumbnail_id($P->ID), 'shop_thumbnail');
        $qcld_large = wp_get_attachment_image_src( get_post_thumbnail_id( $P->ID ), 'single-post-thumbnail' );
        if (!empty($qcld_thumb)) {
            $image = $qcld_thumb;
            $image_large =$qcld_large;
        } else {
            $image[0] = QCLD_EXPRESS_IMG_URL . '/placeholder.png';
            $image_large[0]=QCLD_EXPRESS_IMG_URL.'/placeholder.png';
        }
        if ($counter % 2 == 0 && $qcld_express_template == "slope") {
            if ($qcld_express_slope_type == 'left') {
                $qcld_express_extra_class = "left-slope";
                $qcld_express_slope_type = 'right';
            } else {
                $qcld_express_extra_class = "right-slope";
                $qcld_express_slope_type = 'left';
            }

        } else {
            $qcld_express_extra_class = "";
        }

        $html .= '<div class="qcld-express-row '. $qcld_express_extra_class .'">';
        //SKu show or not
        if (isset($qcld_express_sku) && $qcld_express_sku == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-sku-cell"><p class="qcld-express-sku">'. $product->get_sku() .'</p></div>';
        }
        //Thumbnail show or not
        if (isset($qcld_express_thumbnail) && $qcld_express_thumbnail == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-thumb-cell"><img class="qlcd-express-list-thumb" src="' . $image[0] . '"  alt="' . get_the_title($P->ID) . '"/></div>';


        }
        //Title show or not
        if (isset($qcld_express_title) && $qcld_express_title == 'on') {

            $html .= '<div class="qcld-express-cell qcld-express-title-cell"><h3 class="qcld-express-title">';
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            $html .='<a href="#" class="qcld_express_product_details"  product-id="'.$P->ID.'">' . get_the_title($P->ID) . '</a>';
            }else{ 
            $html .='<a href="'.get_the_permalink($P->ID).'"  product-id="'.$P->ID.'">' . get_the_title($P->ID) . '</a>';
            }

            if(isset($qcld_express_category_show_above_tite) && $qcld_express_category_show_above_tite == 'on' ){
                $html .= '<p class="qcld-express-categorie">'.wc_get_product_category_list($P->ID).'</p>';
            }

            $html .= '</h3></div>';

        }
        //Description show or not
        if (isset($qcld_express_description) && $qcld_express_description == 'on') {

                $html .= '<div class="qcld-express-cell qcld-express-desc-cell"><p class="qcld-express-desc">' . strip_tags(substr(get_the_excerpt($P->ID), 0, $qcld_express_short_description_set_character)) . ' ... ';

             if(isset($qcld_express_details_button) && $qcld_express_details_button == 'on' ){
      
              $html .='<a href="#"  class="qcld_express_product_details" product-id="'.$P->ID.'">
                  <i class="fa fa-info-circle" aria-hidden="true"></i>
              </a>';
            }
           
            $html .='</p></div>';
        }

        //Tag show or not
        if(isset($qcld_express_tag) && $qcld_express_tag == 'on' ){
         
        $html .='<div class="qcld-express-cell qcld-express-desc-cell">';
              $html .='<p class="qcld-express-desc">';
                
                $qcld_output = array();

                $qcld_terms = wp_get_post_terms( $P->ID, 'product_tag' );

                if( count($qcld_terms) > 0 ){
                    foreach($qcld_terms as $term){
                        $term_id = $term->term_id;
                        $term_name = $term->name;
                        $term_slug = $term->slug;
                        $term_link = get_term_link( $term, 'product_tag' );

                        $qcld_output[] = '<a href="'.$term_link.'">'.$term_name.'</a>';
                    }
                    $qcld_output = implode( ', ', $qcld_output );

                    $html .= $qcld_output;
                }
                
             $html .='</p></div>';
        }


        //Availability show or not
        if (isset($qcld_express_stock) && $qcld_express_stock == 'on') {
            $stock = get_post_meta( get_the_ID(), '_stock', true );
            $html .= '<div class="qcld-express-cell qcld-express-avail-cell"><p class="qcld-express-avail">';
           
            if ($stock > 0) {
                $html .= '<span class="qcld-express-avail-in"> '.$qcld_express_lang_in_stock.' (' . $product->get_stock_quantity() . ')</span>';
            } else if($stock=='') {
                $stock_status = get_post_meta( $P->ID, '_stock_status', true );
                if( $stock_status == "instock" ){ 
                    $html .= '<span class="qcld-express-avail-out"> '.$qcld_express_lang_in_stock.' </span>';
                }else if( $stock_status == "outofstock" ){
                    $html .= '<span class="qcld-express-avail-outs"> '.$qcld_express_lang_out_of_stock.' </span>';
                } 
            }else if($stock<0) {
                $html .= '<span class="qcld-express-avail-out">'.$qcld_express_lang_out_of_stock.'</span>';
            }
            $html .= '</p></div>';
        }


        //Price show or not
        if (isset($qcld_express_price) && $qcld_express_price == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-price-cell"><p class="qcld-express-price">' . $product->get_price_html() . '</p></div>';
        }
        // Action show or not
        if (isset($qcld_express_action) && $qcld_express_action == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-action-cell"><ul class="qcld-express-action">';
            
            if ($product->get_type() == 'simple') {
                
                $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                    $response_min_max = qcld_express_pro_add_rules_text($P->ID,0);

                    $min_qty  = $response_min_max['min'];
                    $max_qty  = $response_min_max['max'];
                    $step_qty = $response_min_max['step'];
        
    
                    $html.='<li><input type="number" value="'.($min_qty ? $min_qty : 1).'" step="'.($step_qty ? $step_qty : '').'" min="'.($min_qty ? $min_qty : '').'" max="'.($max_qty ? $max_qty : '').'" name="qcld_quantity" class="qcld-express-simple-p-qnty"></li>';
                }else{
                $html.='<li><input type="number" value="1" name="qcld_quantity" class="qcld-express-simple-p-qnty"></li>';
                } 
                

              $stock = get_post_meta( get_the_ID(), '_stock', true );
              $stock_status = get_post_meta( $P->ID, '_stock_status', true );
              if( $stock > 0 ){

                    if (isset($qcld_express_cart_mode) && $qcld_express_cart_mode == 'wooinstants') {

                         $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                            $response_min_max = qcld_express_pro_add_rules_text($P->ID,0);
                            $min_qty  = $response_min_max['min'];
                          }else{
                            $min_qty  = 1;

                          }
                     
                     $html .= ' <li><a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple" data-quantity="'.$min_qty.'" data-product_id="' . $P->ID . '" p-id="' . $P->ID . '" p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }else{
                     $html .= ' <li><a  href="#"  class="qcld_express_s_p" p-id="' . $P->ID . '"p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }

               } else if( $stock == "" ){
               if( $stock_status == "instock" ){
                     if (isset($qcld_express_cart_mode) && $qcld_express_cart_mode == 'wooinstants') { 

                        $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                            $response_min_max = qcld_express_pro_add_rules_text($P->ID,0);
                            $min_qty  = $response_min_max['min'];
                          }else{
                            $min_qty  = 1;

                          }
                     
                     $html .= ' <li><a  href="#"  class="ajax_add_to_cart add_to_cart_button product_type_simple" data-quantity="'.$min_qty.'" data-product_id="' . $P->ID . '" p-id="' . $P->ID . '" p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }else{
                     $html .= ' <li><a  href="#"  class="qcld_express_s_p" p-id="' . $P->ID . '"p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';
                    }

                } else if( $stock_status == "outofstock" ){ 
                    $html .= ' <li><a href="#" class="qcld_express_out_of_pro" p-id="' . $P->ID . '"p-price="' . $product->get_price() . '" > <i class="fa fa-shopping-cart"></i> </a></li>';

                 } 
                }else if( $stock < 1 ){ 
                     $html .= ' <li><a  href="#"  class="qcld_express_s_p" p-id="' . $P->ID . '"p-price="' . $product->get_price() . '" ><i class="fa fa-shopping-cart"></i></a></li>';

                } 


            }
            
            if($product->get_type() == 'external'){

              $link = sprintf( '<a rel="nofollow" href="%s" data-quantity="%s" data-product_id="%s" data-product_sku="%s" class="%s" target="_blank">%s</a>',
                      esc_url( $product->add_to_cart_url() ),
                      esc_attr( isset( $quantity ) ? $quantity : 1 ),
                      esc_attr( $product->get_id() ),
                      esc_attr( $product->get_sku() ),
                      esc_attr( isset( $class ) ? $class : 'qcld_product_type_external' ),
                      esc_html( $product->add_to_cart_text() )
                      );
              $html .= $link;

            }else if ($product->get_type() == 'variable') {
                

              $stock = get_post_meta( get_the_ID(), '_stock', true );
              $stock_status = get_post_meta( $P->ID, '_stock_status', true );
              if( $stock > 0 ){
              $html .= ' <li><a href="#" class="qcld_express_v_p" p-id="' . $P->ID . '"><i class="fa fa-shopping-cart"></i></a></li>';

               } else if( $stock == "" ){
               if( $stock_status == "instock" ){
                    $html .= ' <li><a href="#" class="qcld_express_v_p" p-id="' . $P->ID . '"><i class="fa fa-shopping-cart"></i></a></li>';

                } else if( $stock_status == "outofstock" ){ 
                    $html .= ' <li><a href="#" class="qcld_express_out_of_pro" p-id="' . $P->ID . '"><i class="fa fa-shopping-cart"></i></a></li>';

                 } 
                }else if( $stock < 1 ){ 
                    $html .= ' <li><a href="#" class="qcld_express_v_p" p-id="' . $P->ID . '"><i class="fa fa-shopping-cart"></i></a></li>';
                } 

            }

            $html .= '</ul>';

            $qcld_woo_minmax_dynamic_pricing_setting = get_option('qcld_woo_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_minmax_install') && (isset($qcld_woo_minmax_dynamic_pricing_setting['qcld_woo_minmax_price_table_on_off']) && $qcld_woo_minmax_dynamic_pricing_setting['qcld_woo_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_express_pro_dynamic_discount_price_table_show(get_the_ID());
              $html .= $result_show;
            }

            
            $html .= '</div>';
        }//End of show or not
        $html .= '</div>';

        $counter++;
    } //End of loop


    $response = array('offset' => $nextOffset, 'cat_type_id' => $_POST['c_id'], 'html' => $html);
    echo wp_send_json($response);


}



add_action('wp_ajax_qcld_express_pro_video_info', 'qcld_express_pro_video_info');
add_action('wp_ajax_nopriv_qcld_express_pro_video_info', 'qcld_express_pro_video_info');

function qcld_express_pro_video_info(){

    check_ajax_referer( 'qcld_express_security_nonce', 'security');

    $qcld_express_options                       = get_option('qcld_express_options');

    $qcld_express_lightbox_add_to_cart_button   = $qcld_express_options['qcld_express_lightbox_add_to_cart_button'];
   
    $video_type = $_POST['video_type'];
    $video_host = $_POST['video_host'];
    $video_url = $_POST['video_url'];

    // id // url // embd // upload

    if($video_type == 'id' && $video_host == 'youtube'){
    ?>
    <iframe class="qcld_express_video_iframe" width="100%" height="350" allowfullscreen src="https://www.youtube.com/embed/<?php echo esc_attr($video_url) ?>"></iframe>
    <?php 
    }

    if($video_type == 'id' && $video_host == 'vimeo'){
    ?>
    <iframe class="qcld_express_video_iframe" width="100%" height="350" allowfullscreen src="//player.vimeo.com/video/<?php echo esc_attr($video_url) ?>"></iframe>
    <?php 
    }

    if($video_type == 'url' && $video_host == 'youtube'){
    ?>
    <iframe class="qcld_express_video_iframe" width="100%" height="350" allowfullscreen src="https://www.youtube.com/embed/<?php echo esc_attr($video_url) ?>"></iframe>
    <?php 
    }

    if($video_type == 'url' && $video_host == 'vimeo'){
    ?>
    <iframe class="qcld_express_video_iframe" width="100%" height="350" allowfullscreen src="//player.vimeo.com/video/<?php echo esc_attr($video_url) ?>"></iframe>
    <?php 
    }

    if($video_host == 'host'){
    ?>
    <iframe class="qcld_express_video_iframe" width="100%" height="350" allowfullscreen src="<?php echo esc_attr($video_url) ?>"></iframe>
    <?php 
    }

    if($video_host == 'embedded'){
    
        echo urldecode($video_url);

    }


    echo  ob_get_clean();
    exit();
    
}