<?php

defined('ABSPATH') or die("No direct script access!");

//Loading frontend style & scripts based on the above condition.
function qcld_express_pro_load_front_scriptsss(){

    if (is_cart() || is_checkout()) {
        return false;
    }

    global $post;
    if( is_a( $post, 'WP_Post' ) && has_shortcode( $post->post_content, 'qcld_express_shop') ) {

        //Styles
        wp_enqueue_style( 'qcld_express_fontawesome_css', QCLD_EXPRESS_ASSETS_URL . '/css/font-awesome.min.css');
        wp_enqueue_style('sweetalert2');
        wp_register_style( 'qcld_express_front_css', QCLD_EXPRESS_ASSETS_URL . '/css/qcld-express-custom-front.css');
        wp_enqueue_style('qcld_express_front_css');
        wp_enqueue_script( 'qcld_express_fronts_js', QCLD_EXPRESS_ASSETS_URL . '/js/qcld-express-custom-cart-front.js', array('jquery'), '', true);

    }

}
add_action('wp_enqueue_scripts', 'qcld_express_pro_load_front_scriptsss',200,2);


//Loading frontend style & scripts based on the above condition.
function qcld_express_pro_load_front_scripts(){

    if (is_cart() || is_checkout()) {
        return false;
    }

    global $post;
    if( is_a( $post, 'WP_Post' ) && has_shortcode( $post->post_content, 'qcld_express_shop') ) {

    // wp_register_style('sweetalert2', QCLD_EXPRESS_ASSETS_URL . '/css/sweetalert2.css');
    // wp_enqueue_style('sweetalert2');

    //Styles
    wp_enqueue_style( 'qcld_express_fontawesome_css', QCLD_EXPRESS_ASSETS_URL . '/css/font-awesome.min.css');
    wp_enqueue_style('qcld_express_fontawesome_css');

    wp_register_style( 'qcld_express_frontend_css', QCLD_EXPRESS_ASSETS_URL . '/css/qcld-express-custom-front.css');
    wp_enqueue_style('qcld_express_frontend_css');


    $qcld_express_options               = get_option('qcld_express_options');
    $qcld_express_custom_style          = $qcld_express_options['qcld_express_custom_style'];
    $qcld_express_audio_feature_product = $qcld_express_options['qcld_express_audio_feature_product'];

    wp_add_inline_style( 'qcld_express_frontend_css', $qcld_express_custom_style );

    wp_register_style( 'qcld_express_magnific_css', QCLD_EXPRESS_ASSETS_URL . '/css/qcld-express-magnific-popup.css');
    wp_enqueue_style('qcld_express_magnific_css');
    wp_register_style( 'qcld_express_front_rwd_css', QCLD_EXPRESS_ASSETS_URL . '/css/qcld-express-custom-front-rwd.css');
    wp_enqueue_style('qcld_express_front_rwd_css');
    wp_register_style( 'qcld_express_slick_css', QCLD_EXPRESS_ASSETS_URL . '/css/qcld-express-slick.css');
    wp_enqueue_style('qcld_express_slick_css');
    wp_register_style( 'qcld_express_sweet_alert_css', QCLD_EXPRESS_ASSETS_URL . '/css/qcld-express-sweet-alert.css');
    wp_enqueue_style('qcld_express_sweet_alert_css');
    wp_register_style( 'qcld_express_lightslider_css', QCLD_EXPRESS_ASSETS_URL . '/css/qcld-express-lightslider.css');
    wp_enqueue_style('qcld_express_lightslider_css');
    wp_register_style( 'qcld_express_animate_css', QCLD_EXPRESS_ASSETS_URL . '/css/qcld-express-animate.css');
    wp_enqueue_style('qcld_express_animate_css');

    //Scripts
    wp_enqueue_script( 'jquery', 'jquery');
	wp_enqueue_script( 'wc-add-to-cart-variation' );

    wp_enqueue_script( 'qcld_express_modal_cart_js', QCLD_EXPRESS_ASSETS_URL . '/js/qcld-express-modal-cart.js', array('jquery'), '', true);

    wp_enqueue_script( 'qcld_express_magnific_js', QCLD_EXPRESS_ASSETS_URL . '/js/qcld-express-jquery.magnific-popup.min.js', array('jquery'), '', true);
    wp_enqueue_script( 'qcld_express_slick_js', QCLD_EXPRESS_ASSETS_URL . '/js/qcld-express-slick.js', array('jquery'), '', true);
    wp_enqueue_script( 'qcld_express_sticky_js', QCLD_EXPRESS_ASSETS_URL . '/js/qcld-express-jquery.sticky.js', array('jquery'), '', true);
    wp_enqueue_script( 'qcld_express_sweet_alert_js', QCLD_EXPRESS_ASSETS_URL . '/js/qcld-express-sweet-alert.js', array('jquery'), '', true);
    wp_enqueue_script( 'qcld_express_lightslider_js', QCLD_EXPRESS_ASSETS_URL . '/js/qcld-express-lightslider.js', array('jquery'), '', true);
    wp_enqueue_script( 'qcld_express_front_js', QCLD_EXPRESS_ASSETS_URL . '/js/qcld-express-custom-front.js', array('jquery','qcld_express_magnific_js','qcld_express_slick_js','qcld_express_sticky_js','wc-add-to-cart-variation'), '', true);

    $qcld_express_options = get_option('qcld_express_options');
    $qcld_express_cart_mode=$qcld_express_options['qcld_express_cart_mode'];
    $qcld_quick_cart_stop_expand=$qcld_express_options['qcld_express_floating_quick_cart_stop_expand'];
    $qcld_express_active_body_bg=$qcld_express_options['qcld_express_active_body_bg'] ? $qcld_express_options['qcld_express_active_body_bg'] : 'rgba(0,0,0,0.4)';
    $qcld_express_show_category_dropdown=$qcld_express_options['qcld_express_show_category_dropdown'];
    $qcld_express_show_catelog_dropdown=$qcld_express_options['qcld_express_show_catelog_dropdown'];
    $qcld_express_plus_minus_icon_qty = $qcld_express_options['qcld_express_plus_minus_icon_qty'];
    $qcld_express_scroll_category_clickable = $qcld_express_options['qcld_express_scroll_category_clickable'];

    wp_add_inline_script( 'qcld_express_front_js', '
            var ajaxurl = "' . admin_url( 'admin-ajax.php', is_ssl() ? 'https' : 'http' ) . '"; 
            var qcld_express_image_loader = "' . QCLD_EXPRESS_IMG_URL . '/product-loader.gif";
            var cart_preloader = "' . QCLD_EXPRESS_IMG_URL . '/cart-preloader.gif";
            var currency_symbol = "' . get_woocommerce_currency_symbol() . '" ;
            var cart_mode = "' . $qcld_express_cart_mode . '" ;
            var qcld_get_checkout_url = "' . wc_get_checkout_url(). '";
            var qcld_quick_cart_stop_expand = "' . $qcld_quick_cart_stop_expand . '";
            var qcld_express_active_body_bg = "' . $qcld_express_active_body_bg . '";
            var qcld_express_show_category_dropdown = "' . $qcld_express_show_category_dropdown . '";
            var qcld_express_show_catelog_dropdown = "' . $qcld_express_show_catelog_dropdown . '";
            var qcld_express_plus_minus_icon_qty = "' . $qcld_express_plus_minus_icon_qty . '";
            var qcld_express_scroll_category_clickable = "' . $qcld_express_scroll_category_clickable . '";
            var qcld_express_security_nonce = "' . wp_create_nonce('qcld_express_security_nonce') . '";
    ');

    wp_register_style( 'qcld_express_audio_css', QCLD_EXPRESS_ASSETS_URL . '/css/qcld-express-audio.css');
    wp_enqueue_style('qcld_express_audio_css');
    wp_enqueue_script( 'qcld_express_audio_js', QCLD_EXPRESS_ASSETS_URL . '/js/qcld-express-audio.js', array('jquery'), '', true);

        $add_inline_styles  = ' button.qcld_express_play {background: url('.QCLD_EXPRESS_ASSETS_URL.'/images/play.png) no-repeat; }';
        $add_inline_styles .= ' button.qcld_express_pause {background: url('.QCLD_EXPRESS_ASSETS_URL.'/images/pause.png) no-repeat; }';

        wp_add_inline_style( 'qcld_express_audio_css', $add_inline_styles );
       
    }

}

add_action('wp_enqueue_scripts', 'qcld_express_pro_load_front_scripts', 200,2);
//Loading admin panel's requried Style & scripts
function qcld_express_pro_load_admin_scripts(){
    
    //Styles
    wp_enqueue_style( 'qcld_express_admin_light_css', QCLD_EXPRESS_ASSETS_URL . "/css/qcld-express-custom-admin.css");
    wp_enqueue_style( 'wp-color-picker' );

    //Scripts
    wp_enqueue_script( 'qcld_express_wp_color_picker', QCLD_EXPRESS_ASSETS_URL . '/js/qcld-express-wp-color_picker.js', array( 'wp-color-picker' ), false, true );
    wp_enqueue_script( 'qcld_express_admin_js', QCLD_EXPRESS_ASSETS_URL . "/js/qcld-express-custom-admin.js", array('jquery'), '', true);

    $audio_placeholder_id = get_option( 'qcld_express_audio_placeholder_id' );

    $qcld_ajax = array(
                'admin_url'                     => admin_url( 'admin-ajax.php', is_ssl() ? 'https' : 'http' ),
                'audio_placeholder_img_src'     => QCLD_EXPRESS_ASSETS_URL . 'images/audioplaceholder.jpg',
                'audio_placeholder_img_id'      => $audio_placeholder_id,
                'qcld_express_security_nonce'   => wp_create_nonce('qcld_express_security_nonce'),
                'actions'                       => array(
                    'save_thumbnail_video'      => 'save_thumbnail_video',
                    'add_new_video_row'         => 'add_new_video_row',
                    'add_new_audio_row'         => 'add_new_audio_row',
                    'add_new_video_variation'   => 'add_new_video_variation'
                )
            );
    wp_localize_script( 'qcld_express_admin_js', 'qcld_ajax', $qcld_ajax );
}
add_action( 'admin_enqueue_scripts', 'qcld_express_pro_load_admin_scripts');