<?php 

if( !defined( 'ABSPATH' ) ) exit;

add_filter( 'woocommerce_product_write_panel_tabs', 'qcld_express_print_audio_product_panels' );

function qcld_express_print_audio_product_panels() {
    ?>
    <style type="text/css">
        #woocommerce-product-data ul.wc-tabs .qcld_express_video_data_tab a:before, #woocommerce-product-data ul.wc-tabs .qcld_express_audio_data_tab a:before {
            content: '';
            display: none;
        }

        /* AUDIO METABOXES*/
.wc-metaboxes-wrapper#qcld_express_audio_data .toolbar.toolbar-top{
    height: 30px;
}
.wc-metaboxes-wrapper#qcld_express_audio_data .expand-close {
    float: right;
    line-height: 28px;
}

.qcld_express_form_audio_container{
    padding: 10px;
	height: auto;
    min-height: 70px;
}

.qcld_express_form_audio_container .audio_name{
    width: 20%;
    float: left;
}
.qcld_express_form_audio_container .audio_url{
    width: 30%;
    float: left;
}
.qcld_express_form_audio_container .audio_button {
    width: 10%;
    float: left;
}

.qcld_express_form_audio_container #qcld_express_audio_url, .qcld_express_form_audio_container #qcld_express_audio_ogg_url{
    width: 60%;
}
.qcld_express_form_audio_container .qcld_express_upload_image_button{
    width: 70px;
}
.qcld_express_form_audio_container .audio_button button{
   margin-top: 33px;
}

.qcld_express_audio_image{
    width: 200px;
}

.qcld_express_thumbn_error, .qcld_express_audio_image{
    padding: 0;
}

.qcld_express_audio_image a.qcld_express_upload_image_button{
    display: block;
    width: 100%;
    position: relative;
}

.qcld_express_audio_image a.qcld_express_upload_image_button .qcld_express_thumbn{
    width: 100%;
    height: 150px;
}

.qcld_express_audio_image a.qcld_express_upload_image_button:before{
    content: "\f317";
    font-family: Dashicons;
    display: none;
    position: absolute;
    font-size: 26px;
    font-weight: 400;
    -webkit-font-smoothing: antialiased;
    top: 50%;
    left: 50%;
    margin-left: -13px;
    margin-top: -13px;
}
.qcld_express_audio_image a.qcld_express_upload_image_button:hover:before{
    display: block;
}

.wc-metaboxes-wrapper .wc-metabox table td.qcld_express_thumbn_error .qcld_express_thumbn_error_container
{
    border:1px solid red;
    border-left: none;
    background: #fff4f4;
    font-size: 12px;
    font-weight: bold;
    color:red;
    width: 92%;
    padding: 11px;
    text-align: left;
    margin-top: 21px;
    display: inline-block;
    height: 80%;
}

.qcld_express_thumbn_error .qcld_express_thumbn_error_container .qcld_express_icon_error:before{
    content: "\f153";
    font-family: Dashicons;
    font-size: 17px;
    color:red;
    -webkit-font-smoothing: antialiased;
    vertical-align: bottom;
}

.error_field {
    border-color: red !important;
}

.qcld_express_audio_title input {
    float: left;
    min-width: 200px;
}

.qcld_express_audio_image {
    width: 200px;
}

.qcld_express_upload_image_button {
    display: block;
    width: 100%;
    position: relative;
}


    </style>

   
    <li class="qcld_express_audio_data_tab">
        <a href="#qcld_express_audio_data">
            <i class="dashicons dashicons-format-audio"></i>&nbsp;&nbsp;<?php _e( 'Audio', 'express-shop-pro' ); ?>
        </a>
    </li>

    <?php
    add_action( 'woocommerce_product_data_panels', 'qcld_express_write_audio_product_panels' );
}

if( !function_exists( 'qcld_express_write_audio_product_panels' ) ){

function qcld_express_write_audio_product_panels() {

	global $post, $product_object;

	$product_id = ! empty( $product_object ) && is_callable( array( $product_object, 'get_id' ) ) ? $product_object->get_id() : $post->ID;

	$qcld_express_audio_title  		=   unserialize( get_post_meta( $product_id, 'qcld_express_audio_title', true ));
    $qcld_express_audio_url         =   unserialize( get_post_meta( $product_id, 'qcld_express_audio_url', true ));
	$qcld_express_audio_ogg_url  	=   unserialize( get_post_meta( $product_id, 'qcld_express_audio_ogg_url', true ));
	$qcld_express_audio_thumbn  	=   unserialize( get_post_meta( $product_id, 'qcld_express_audio_thumbn', true ));

?>


<div id="qcld_express_audio_data" class="panel wc-metaboxes-wrapper">
    <div class="toolbar toolbar-top">
        <span class="expand-close">
            <a href="#" class="expand_all"><?php _e( 'Expand', 'woocommerce' ); ?></a> / <a href="#" class="close_all"><?php _e( 'Close', 'woocommerce' ); ?></a>
        </span>
        <strong><?php _e( 'Product Audio', 'express-shop-pro' );?></strong>
    </div>
    <div class="product_audio wc-metaboxes">
        <?php
        if( !empty( $qcld_express_audio_title ) ){

            foreach( $qcld_express_audio_title as $index => $audio_title ){

            	?>


            	<div class="qcld_express_woocommerce_audio wc-metabox closed"><h3>
					        <a href="#" class="qcld_express_delete_audio delete">Remove</a>
					        <div class="handlediv" title="<?php echo esc_attr( 'Click to toggle', 'woocommerce' ); ?>"></div>
					        <strong class="attribute_name"> <?php echo esc_html( $audio_title ); ?> </strong>
					    </h3>
					    <div class="qcld_express_woocommerce_audio_data wc-metabox-content ">

					        <div class="qcld_express_form_audio_container">
						        <div class="form-field">
					                <span class="audio_name">
					                    <label for="qcld_express_audio_name"><?php _e( 'Audio Name', 'express-shop-pro' );?></label>
					                    <p><input type="text" id="qcld_express_audio_name" name="qcld_express_audio_title[]" value="<?php echo esc_attr($audio_title); ?>" /></p>
					                </span>
                                    <span class="audio_url">
                                        <label for="qcld_express_audio_url"><?php _e( 'MP3 Audio URL', 'express-shop-pro' );?></label>
                                        <p><input type="text" id="qcld_express_audio_url" class="qcld_express_audio_url" name="qcld_express_audio_url[]" value="<?php echo esc_url( $qcld_express_audio_url[$index] ); ?>" />or <button type="button" class="button button-primary qcld_express_upload_image_button">Upload</button></p>
                                        
                                    </span>
					                <span class="audio_url">
					                    <label for="qcld_express_audio_ogg_url"><?php _e( 'Ogg Audio URL ( Optional )', 'express-shop-pro' );?></label>
					                    <p><input type="text" id="qcld_express_audio_ogg_url" class="qcld_express_audio_ogg_url" name="qcld_express_audio_ogg_url[]" value="<?php echo esc_url( $qcld_express_audio_ogg_url[$index] ); ?>" />or <button type="button" class="button button-primary qcld_express_audio_ogg_button">Upload</button></p>
					                    
					                </span>
					            </div>
				            </div>
					    </div>
					</div>


            	<?php

            }
        }
        ?>
    </div>
    <div class="qcld_express_form_audio_container">

        <div class="qcld_express_audio_single_container" >
            <div class="form-field">
                <span class="audio_name">
                    <label for="qcld_express_audio_name"><?php _e( 'Audio Name', 'express-shop-pro' );?></label>
                    <p><input type="text" id="qcld_express_audio_name" name="qcld_express_audio_name" /></p>
                </span>
                <span class="audio_url">
                    <label for="qcld_express_audio_url"><?php _e( 'MP3 Audio URL', 'express-shop-pro' );?></label>
                    <p><input type="text" id="qcld_express_audio_url" class="qcld_express_audio_url" name="qcld_express_audio_url[]" />or <button type="button" class="button button-primary qcld_express_upload_image_button">Upload</button></p>
                    
                </span>
                <span class="audio_url">
                    <label for="qcld_express_audio_ogg_url"><?php _e( 'Ogg Audio URL (Optional)', 'express-shop-pro' );?></label>
                    <p><input type="text" id="qcld_express_audio_ogg_url" class="qcld_express_audio_ogg_url" name="qcld_express_audio_ogg_url[]" />or <button type="button" class="button button-primary qcld_express_audio_ogg_button">Upload</button></p>
                    
                </span>
                <span class="audio_button">
                    <button type="button" class="button button-primary qcld_express_insert_track"><?php _e( 'Add Audio Track', 'express-shop-pro' ) ?></button>
                </span>
            </div>
        </div>
    </div>
    <?php do_action( 'qcld_express_woocommerce_product_options_audios' ); ?>

</div>


<?php 
}

}

//add new audio row
add_action( 'wp_ajax_add_new_audio_row', 'qcld_express_add_new_audio_row' );
add_action( 'wp_ajax_nopriv_add_new_audio_row', 'qcld_express_add_new_audio_row' );

if( !function_exists( 'qcld_express_add_new_audio_row' ) ){

	function qcld_express_add_new_audio_row() {

		if ( isset( $_POST['audio_id'] ) ) {

			global $post, $product_object;

			$product_id = ! empty( $product_object ) && is_callable( array( $product_object, 'get_id' ) ) ? $product_object->get_id() : $post->ID;
		
			// update_post_meta( $product_id, 'qcld_express_audio_title', serialize( $_POST['audio_name'] ));
			// update_post_meta( $product_id, 'qcld_express_audio_url', serialize( $_POST['audio_content'] ));
            // update_post_meta( $product_id, 'qcld_express_audio_thumbn', serialize( $_POST['audio_img'] ));
			// update_post_meta( $product_id, 'qcld_express_audio_ogg_url', serialize( $_POST['ogg_audio_url'] ));

			ob_start();
			$template = '<div class="qcld_express_woocommerce_audio wc-metabox closed"><h3>
					        <a href="#" class="qcld_express_delete_audio delete">Remove</a>
					        <div class="handlediv" title="'.esc_attr( 'Click to toggle', 'woocommerce' ).'"></div>
					        <strong class="attribute_name">'.esc_html( $_POST['audio_name'] ).'</strong>
					    </h3>
					    <div class="qcld_express_woocommerce_audio_data wc-metabox-content">
					       
					        <div class="qcld_express_form_audio_container">
						        <div class="form-field">
					                <span class="audio_name">
					                    <label for="qcld_express_audio_name">'.esc_html( "Audio Name", "express-shop-pro" ).'</label>
					                    <p><input type="text" id="qcld_express_audio_name" name="qcld_express_audio_title[]" value="'.esc_attr($_POST['audio_name']).'" /></p>
					                </span>
                                    <span class="audio_url">
                                        <label for="qcld_express_audio_url">'.esc_html( "MP3 Audio URL", "express-shop-pro" ).'</label>
                                        <p><input type="text" id="qcld_express_audio_url" class="qcld_express_audio_url" name="qcld_express_audio_url[]" value="'.esc_url( $_POST['audio_content'] ).'" />or <button type="button" class="button button-primary qcld_express_upload_image_button">Upload</button></p>
                                        
                                    </span>
					                <span class="audio_url">
					                    <label for="qcld_express_audio_ogg_url">'.esc_html( "Ogg Audio URL (Optional)", "express-shop-pro" ).'</label>
					                    <p><input type="text" id="qcld_express_audio_ogg_url" class="qcld_express_audio_ogg_url" name="qcld_express_audio_ogg_url[]" value="'.esc_url( $_POST['ogg_audio_url'] ).'" />or <button type="button" class="button button-primary qcld_express_audio_ogg_button">Upload</button></p>
					                    
					                </span>
					            </div>
				            </div>


					    </div>
					</div>';
			ob_end_clean();

			wp_send_json( array( 'result' => $template ) );
			die;

		}

	}
}



add_action( 'woocommerce_process_product_meta', 'qcld_express_audio_save_product_meta' );

if( !function_exists( 'qcld_express_audio_save_product_meta' ) ){

	function qcld_express_audio_save_product_meta( $post_id ) {

		
		$product = wc_get_product( $post_id );

		delete_post_meta( $post_id, 'qcld_express_audio_title');
		delete_post_meta( $post_id, 'qcld_express_audio_url');
        delete_post_meta( $post_id, 'qcld_express_audio_thumbn');
		delete_post_meta( $post_id, 'qcld_express_audio_ogg_url');

		$title            = isset( $_POST['qcld_express_audio_title'] )   ? $_POST['qcld_express_audio_title'] :  '';
		$url              = isset( $_POST['qcld_express_audio_url'] )     ? $_POST['qcld_express_audio_url'] :    '';
        $audio_thumbn     = isset( $_POST['qcld_express_audio_thumbn'] )  ? $_POST['qcld_express_audio_thumbn'] : '';
		$audio_ogg_url    = isset( $_POST['qcld_express_audio_ogg_url'] ) ? $_POST['qcld_express_audio_ogg_url']: '';

		global $post, $product_object;

		$product_id = ! empty( $product_object ) && is_callable( array( $product_object, 'get_id' ) ) ? $product_object->get_id() : $post->ID;

		
		update_post_meta( $post_id, 'qcld_express_audio_title', serialize($title ));
		update_post_meta( $post_id, 'qcld_express_audio_url', serialize($url ));
        update_post_meta( $post_id, 'qcld_express_audio_thumbn', serialize($audio_thumbn ));
		update_post_meta( $post_id, 'qcld_express_audio_ogg_url', serialize($audio_ogg_url ));

	}

}