<?php

defined( 'ABSPATH' ) || exit;

function qcld_express_pro_cart_fragments( $fragments ) {
	global $woocommerce;

    ob_start();
    qcld_express_pro_cart_count();
    $fragments['span.qcld_express_cart_total'] = ob_get_clean();

    ob_start();
    qcld_express_pro_checkout_inner();
    $fragments['div.qcld-express-checkout-inner'] = ob_get_clean();
    
    return $fragments;
    
}
add_filter( 'woocommerce_add_to_cart_fragments', 'qcld_express_pro_cart_fragments', 10, 1 );

/**
 * Cart Count function 
 */
if ( ! function_exists( 'qcld_express_pro_cart_count' ) ) {
	function qcld_express_pro_cart_count() { ?>		
		<span class="qcld_express_cart_total">
			<script type='text/javascript'>
			/* <![CDATA[ */
				var wiCartTotal = <?php echo WC()->cart->get_cart_contents_count(); ?>;
			/* ]]> */
			</script>
			<?php if ( WC()->cart->get_cart_contents_count() == 0 ) : ?>
				<style type="text/css" version="1.0">
					.qcld-express-container{
					    right: -50% !important;
					}
					.qcld-express-cart-header.hascart {
					    left: -70px !important;
					}
					@media (max-width: 767px){
					    .qcld-express-container{
					        right: -100% !important;
					    }
					}
				</style>
			<?php endif; ?>
			<?php echo WC()->cart->get_cart_contents_count(); ?>
		</span> <?php
	}
}

/**
 * Cart Area function
 */
if ( ! function_exists( 'qcld_express_pro_cart_inner' ) ) {
	function qcld_express_pro_cart_inner() { 
		include plugin_dir_path( __FILE__ ) . '/inc/cart/cart.php';
	}
}

/**
 * Checkout Area function
 */
if ( ! function_exists( 'qcld_express_pro_checkout_inner' ) ) {
	function qcld_express_pro_checkout_inner() { ?>
		<div class="qcld-express-checkout-inner">
			<button type="button" class="button alt" id="back_to_cart"><?php echo esc_attr('Back to cart','wooinstant'); ?></button>
			<?php echo do_shortcode('[woocommerce_checkout]');  ?>
		</div> <?php
	}
}

/**
 * Add wooinstant-active class to body
 */
function qcld_express_pro_body_classes( $classes ) {
	$classes[] = 'wooinstant-active';
	return $classes;
}
add_filter( 'body_class', 'qcld_express_pro_body_classes' );

/**
 * Calculate Shipping on Update Order Review
 */
function qcld_express_pro_action_woocommerce_checkout_update_order_review( $posted_data ) {
    WC()->cart->calculate_shipping();
}
add_action( 'woocommerce_checkout_update_order_review', 'qcld_express_pro_action_woocommerce_checkout_update_order_review', 10, 1 );

/**
 *	WooInstant Ajax functions
 */
// variable product quick view ajax actions
add_action('wp_ajax_qcld_express_variable_product_quick_view', 'qcld_express_pro_ajax_quickview_variable_products');
add_action('wp_ajax_nopriv_qcld_express_variable_product_quick_view', 'qcld_express_pro_ajax_quickview_variable_products');

// variable product quick view ajax function
function qcld_express_pro_ajax_quickview_variable_products(){
	global $post, $product, $woocommerce;
	check_ajax_referer( 'qcld_express_ajax_nonce', 'security', false );

	add_action( 'wcqv_product_data', 'woocommerce_template_single_add_to_cart');

	$product_id = $_POST['product_id'];
    $wiqv_loop = new WP_Query(
        array(
            'post_type' => 'product',
            'p' => $product_id,
        )
    );

    ob_start();
	if( $wiqv_loop->have_posts() ) :
		while ( $wiqv_loop->have_posts() ) : $wiqv_loop->the_post(); ?>
			<?php wc_get_template( 'single-product/add-to-cart/variation.php' ); ?>
			<script>    
	            jQuery.getScript("<?php echo $woocommerce->plugin_url(); ?>/assets/js/frontend/add-to-cart-variation.min.js");
	 	    </script> <?php 
			do_action( 'wcqv_product_data' );
	 	endwhile;
	endif;

	echo ob_get_clean();

	wp_die();
}
