<?php 

if( !defined( 'ABSPATH' ) ) exit;

add_filter( 'woocommerce_product_write_panel_tabs', 'qcld_express_print_video_product_panels' );

function qcld_express_print_video_product_panels() {
	?>
            <style type="text/css">
                #woocommerce-product-data ul.wc-tabs .qcld_express_video_data_tab a:before, #woocommerce-product-data ul.wc-tabs .qcld_express_audio_data_tab a:before {
                    content: '';
                    display: none;
                }



/*VIDEO METABOX*/
.wc-metaboxes-wrapper#qcld_express_video_data .toolbar.toolbar-top{
    height: 30px;
}
.wc-metaboxes-wrapper#qcld_express_video_data .expand-close {
    float: right;
    line-height: 28px;
}

.wc-metaboxes-wrapper .wc-metabox table td.qcld_express_video_image{
    width: 200px;
}

.wc-metaboxes-wrapper .wc-metabox table td.qcld_express_thumbn_error, .wc-metaboxes-wrapper .wc-metabox table td.qcld_express_video_image{
    padding: 0;
}

.wc-metaboxes-wrapper .wc-metabox table td.qcld_express_video_image a.qcld_express_upload_image_button{
    display: block;
    width: 100%;
    position: relative;
}

.wc-metaboxes-wrapper .wc-metabox table td.qcld_express_video_image a.qcld_express_upload_image_button .qcld_express_thumbn{
    width: 100%;
}

.wc-metaboxes-wrapper .wc-metabox table td.qcld_express_video_image a.qcld_express_upload_image_button:before{
    content: "\f317";
    font-family: Dashicons;
    display: none;
    position: absolute;
    font-size: 26px;
    font-weight: 400;
    -webkit-font-smoothing: antialiased;
    top: 50%;
    left: 50%;
    margin-left: -13px;
    margin-top: -13px;
}
.wc-metaboxes-wrapper .wc-metabox table td.qcld_express_video_image a.qcld_express_upload_image_button:hover:before{
    display: block;
}

.wc-metaboxes-wrapper .wc-metabox table td.qcld_express_thumbn_error .qcld_express_thumbn_error_container
{
    border:1px solid red;
    border-left: none;
    background: #fff4f4;
    font-size: 12px;
    font-weight: bold;
    color:red;
    width: 92%;
    padding: 11px;
    text-align: left;
    margin-top: 21px;
    display: inline-block;
    height: 80%;
}

.wc-metaboxes-wrapper .wc-metabox table td.qcld_express_thumbn_error .qcld_express_thumbn_error_container .qcld_express_icon_error:before{
    content: "\f153";
    font-family: Dashicons;
    font-size: 17px;
    color:red;
    -webkit-font-smoothing: antialiased;
    vertical-align: bottom;
}

.wc-metaboxes-wrapper .wc-metabox table td.qcld_express_thumbn_error .qcld_express_thumbn_error_container .qcld_express_txt_error{

    padding-top: 18px;
    padding-bottom: 18px;
}

.qcld_express_video_host_label{
    text-transform: capitalize;
    font-style: italic;
}
.qcld_express_video_host_label.youtube{
    color:#CC181E;
}

.qcld_express_video_content_label{
    font-style: italic;
}
.qcld_express_video_host_label.vimeo
{
color:#4bf;
}

.qcld_express_video_host_type,.qcld_express_video_content{

    padding-top: 15px;
}

#qcld_express_form_container{

    padding: 10px;
}

.qcld_express_video_title, .qcld_express_video_host_type{
	width: 25%;
}
.qcld_express_video_content_wrap{
	width: 50%;
}




            </style>
            <li class="qcld_express_video_data_tab">
                <a href="#qcld_express_video_data">
                    <i class="dashicons dashicons-video-alt2"></i>&nbsp;&nbsp;<?php _e( 'Video', 'express-shop-pro' ); ?>
                </a>
            </li>


<?php

	add_action( 'woocommerce_product_data_panels', 'qcld_express_write_video_product_panels' );


}

if( !function_exists( 'qcld_express_write_video_product_panels' ) ){

	function qcld_express_write_video_product_panels(){

		global $post, $product_object;

	$product_id = ! empty( $product_object ) && is_callable( array( $product_object, 'get_id' ) ) ? $product_object->get_id() : $post->ID;

	$qcld_express_video_name  	=   unserialize( get_post_meta( $product_id, 'qcld_express_video_name', true ));
    $qcld_express_video_type    =   unserialize( get_post_meta( $product_id, 'qcld_express_video_type', true ));
    $qcld_express_video_host    =   unserialize( get_post_meta( $product_id, 'qcld_express_video_host', true ));
	$qcld_express_video_url  	=   unserialize( get_post_meta( $product_id, 'qcld_express_video_url', true ));

	?>


<div id="qcld_express_video_data" class="panel wc-metaboxes-wrapper">
    <div class="toolbar toolbar-top">
	    <span class="expand-close">
		    <a href="#" class="expand_all"><?php _e( 'Expand', 'woocommerce' ); ?></a> / <a href="#" class="close_all"><?php _e( 'Close', 'woocommerce' ); ?></a>
		</span>
        <strong><?php _e( 'Product Video', 'express-shop-pro' );?></strong>
    </div>
    <div class="product_video wc-metaboxes">
        <?php
            if( !empty( $qcld_express_video_name ) ){

                foreach( $qcld_express_video_name as $index => $video_name ){

        ?>

        <div class="qcld_express_woocommerce_video wc-metabox closed">
    <h3>
        <a href="#" class="qcld_express_delete delete"><?php _e( 'Remove', 'woocommerce' ); ?></a>
        <div class="handlediv" title="<?php esc_attr_e( 'Click to toggle', 'woocommerce' ); ?>"></div>
        <strong class="attribute_name"><?php echo esc_html( $video_name ); ?></strong>
    </h3>
    <div class="qcld_express_woocommerce_video_data wc-metabox-content">
        <table cellpadding="0" cellspacing="0">
            <tbody>
	            <tr class="qcld_express_extra_info">
	                <td class="qcld_express_video_title">
	                    <label><?php _e( 'Video Title', 'express-shop-pro' );?></label>
	                    <input type="text" name="qcld_express_video_name[]" value="<?php echo esc_attr($video_name); ?>" />
	                </td>
	                <td class="qcld_express_video_host_type">
	                    <label><?php _e( 'Video Host:', 'express-shop-pro' );?></label>
	                    <span class="qcld_express_video_host_label"><?php echo esc_html($qcld_express_video_host[$index]);?></span>
	                    <input type="hidden" name="qcld_express_video_type[]" value="<?php echo esc_attr($qcld_express_video_type[$index]);?>" />
	                    <input type="hidden" name="qcld_express_video_host[]" value="<?php echo esc_attr($qcld_express_video_host[$index]);?>" />
	                 </td>
	                <td class="qcld_express_video_content">
	                    <div class="qcld_express_video_content_wrap">
	                      
	                        <label><?php echo esc_html($qcld_express_video_host[$index]);?></label>
	                        <span class="qcld_express_video_content_label"><?php echo esc_attr($qcld_express_video_url[$index]); ?></span>
	                        <input type="hidden" class="qcld_express_video_content_url" name="qcld_express_video_url[]" value="<?php echo esc_attr($qcld_express_video_url[$index]); ?>">
	                    </div>
	                </td>
	            </tr>
            </tbody>
        </table>
    </div>
</div>



        <?php 

                  
               }

            }

        ?>
    </div>

        <div id="qcld_express_form_container" class="qcld_express_form_container">

            <p class="video_add_by form-field">
                <label for="qcld_express_video_add_by"><?php _e( 'Add Video', 'express-shop-pro' );?></label>
                <select id="qcld_express_video_add_by">
                    <option value=""><?php _e( 'Select By...', 'express-shop-pro' );?></option>
                    <option value="id"><?php _e( 'By ID', 'express-shop-pro' );?></option>
                    <option value="url"><?php _e( 'By URL', 'express-shop-pro' );?></option>
                    <option value="embd"><?php _e( 'By Embedded code', 'express-shop-pro' );?></option>
                    <option value="upload"><?php _e( 'By Upload', 'express-shop-pro' );?></option>
                </select>
            </p>
            <p class="video_name form-field" style="display: none;">
                <label for="qcld_express_video_name"><?php _e( 'Video Name', 'express-shop-pro' );?></label>
                <input type="text" id="qcld_express_video_name" />
            </p>
            <p class="video_type_host form-field" style="display: none;">
                <label for="qcld_express_video_type_host"><?php _e( 'Host', 'express-shop-pro' );?></label>
                <select id="qcld_express_video_type_host">
                    <option value="youtube"><?php _e('YouTube','express-shop-pro');?></option>
                    <option value="vimeo"><?php _e('Vimeo', 'express-shop-pro');?></option>
                </select>
            </p>
            <p class="video_add_by_id form-field" style="display: none;">
                <label for="qcld_express_video_add_by_id"><?php _e( 'Video ID', 'express-shop-pro' );?></label>
                <span class="description"><?php _e( 'YouTube and Vimeo are supported', 'express-shop-pro' );?></span>
                <input type="text" id="qcld_express_video_add_by_id" class="qcld_express_video_url_up" />
            </p>

            <p class="video_add_by_url form-field" style="display: none;">
                <label for="qcld_express_video_add_by_url"><?php _e( 'Video URL', 'express-shop-pro' );?></label>
                <span class="description"><?php _e( 'YouTube and Vimeo are supported', 'express-shop-pro' );?></span>
                <input type="text" id="qcld_express_video_add_by_url" class="qcld_express_video_url_up" />
            </p>
            <p class="video_add_by_embedded form-field" style="display: none;">
                <label for="qcld_express_video_add_by_embedded"><?php _e( 'Embedded code', 'express-shop-pro' );?></label>
                <textarea id="qcld_express_video_add_by_embedded" class="qcld_express_video_url_up" style="width: 100%;" rows="4"></textarea>
            </p>
            <p class="video_add_by_upload form-field" style="display: none;">
                <button type="button" id="qcld_express_video_add_by_upload" class="button button-primary" data-choose="<?php _e('Select Video', 'express-shop-pro');?>"><?php _e( 'Upload', 'express-shop-pro');?></button>
                <input type="hidden" name="qcld_express_video_url_up" class="qcld_express_video_url_up" value="" id="qcld_express_video_id_up" />
            </p>
            <p class="toolbar">
                <button type="button" class="button button-primary qcld_express_add_video" ><?php _e( 'Add Video', 'express-shop-pro' ) ?></button>
            </p>

        </div>

</div>



	<?php 

	}

}



//add new audio row
add_action( 'wp_ajax_add_new_video_row', 'qcld_express_add_new_video_row' );
add_action( 'wp_ajax_nopriv_add_new_video_row', 'qcld_express_add_new_video_row' );

 function qcld_express_add_new_video_row() {

			if ( isset( $_POST['video_id'] ) ) {

				/*

				$video = array(
					'name'     => $_POST['video_name'],
					'thumbn'   => $_POST['video_img'],
					'featured' => 'no',
					'id'       => $_POST['video_id'],
					'host'     => $_POST['video_host'],
					'content'  => $_POST['video_content'],
					'type'     => $_POST['video_type'],

				);

				$video_params = array(
					'video_params' => $video,
					'loop'         => $_POST['loop'],
					'product_id'   => $_POST['product_id']
				);

				*/

				if($_POST['video_type'] == 'upload'){
					$video_host = 'host';
				}else if($_POST['video_type'] == 'embd'){
					$video_host = 'embedded';
				}else{
					$video_host = $_POST['video_host'];
				}

				ob_start();
				$template = '<div class="qcld_express_woocommerce_video wc-metabox closed">
    						<h3><a href="#" class="qcld_express_delete delete">'.esc_html( 'Remove', 'woocommerce' ).'</a>
					        <div class="handlediv" title="'.esc_attr( 'Click to toggle', 'woocommerce' ).'"></div>
    						<strong class="attribute_name">'.esc_html( $_POST['video_name'] ).'</strong></h3>
						    <div class="qcld_express_woocommerce_video_data wc-metabox-content">
						        <table cellpadding="0" cellspacing="0">
						            <tbody>
						            <tr class="qcld_express_extra_info">
						                <td class="qcld_express_video_title">
						                    <label>'.esc_html( 'Video Title', 'express-shop-pro' ).'</label>
						                    <input type="text" name="qcld_express_video_name[]" value="'.esc_attr( $_POST['video_name'] ).'" />
						                </td>
						                <td class="qcld_express_video_host_type">
						                    <label>'.esc_html( 'Video Host:', 'express-shop-pro' ).'</label>
						                    <span class="qcld_express_video_host_label">'.esc_html( $video_host ).'</span>
						                    <input type="hidden" name="qcld_express_video_type[]" value="'.esc_attr( $_POST['video_type'] ).'" />
						                    <input type="hidden" name="qcld_express_video_host[]" value="'.esc_attr( $video_host ).'" />
						                 </td>
						                <td class="qcld_express_video_content">
						                    <div class="qcld_express_video_content_wrap">
						                        <label>'.esc_html( $video_host ).'</label>
						                        <span class="qcld_express_video_content_label">'.esc_html( $_POST['video_content'] ).'</span>
						                        <input type="hidden" class="qcld_express_video_content" name="qcld_express_video_url[]" value="'.esc_attr( $_POST['video_content'] ).'">
						                    </div>
						                </td>
						            </tr>
						            </tbody>
						        </table>
						    </div>
						</div>';
				ob_end_clean();

				wp_send_json( array( 'result' => $template ) );
				die;

			}
		}




add_action( 'woocommerce_process_product_meta', 'qcld_express_video_save_product_meta' );

if( !function_exists( 'qcld_express_video_save_product_meta' ) ){

	function qcld_express_video_save_product_meta( $post_id ) {

		
			

		$product = wc_get_product( $post_id );

		delete_post_meta( $post_id, 'qcld_express_video_name');
		delete_post_meta( $post_id, 'qcld_express_video_type');
		delete_post_meta( $post_id, 'qcld_express_video_host');
        delete_post_meta( $post_id, 'qcld_express_video_url');

		$title            = isset( $_POST['qcld_express_video_name'] )   ? $_POST['qcld_express_video_name'] :  '';
		$video_type       = isset( $_POST['qcld_express_video_type'] )     ? $_POST['qcld_express_video_type'] :    '';
		$video_host       = isset( $_POST['qcld_express_video_host'] )     ? $_POST['qcld_express_video_host'] :    '';
        $video_url        = isset( $_POST['qcld_express_video_url'] )  ? $_POST['qcld_express_video_url'] : '';

		global $post, $product_object;

		$product_id = ! empty( $product_object ) && is_callable( array( $product_object, 'get_id' ) ) ? $product_object->get_id() : $post->ID;

		
		update_post_meta( $post_id, 'qcld_express_video_name', serialize( $title ));
		update_post_meta( $post_id, 'qcld_express_video_type', serialize( $video_type ));
		update_post_meta( $post_id, 'qcld_express_video_host', serialize( $video_host ));
        update_post_meta( $post_id, 'qcld_express_video_url', serialize( $video_url ));


	}

}